/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 33 "./pgm.override"
#define NO_IMPORT_PYGOBJECT
#include "pygobject.h"
#include <pgm/pgm.h>

/*
 * Convert a Python String or Unicode object to a gchar*. If the object is
 * Unicode, it's encoded to UTF-8. TypeError exception is raised when text
 * parameter is not a String or Unicode object, or when the UTF-8 encoding
 * fails miserably.
 */
static gchar *
encode_string (PyObject *text)
{
  gchar *encoded_string = NULL;

  if (PyUnicode_Check (text))
    {
      gchar *errors;
      PyObject *encoded;

      encoded = PyUnicode_AsEncodedString (text, "utf-8", errors);
      if (!encoded)
        {
          PyErr_Format (PyExc_TypeError, "failed to encode Unicode object: %s",
                        errors);
          return NULL;
        }

      encoded_string = PyString_AS_STRING (encoded);
    }
  else if (PyString_Check (text))
    {
      encoded_string = PyString_AS_STRING (text);
    }
  else
    {
      PyErr_SetString (PyExc_TypeError, "a String or Unicode is required");
      return NULL;
    }

  return encoded_string;
}

#line 52 "./pgm.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)
static PyTypeObject *_PyGstObject_Type;
#define PyGstObject_Type (*_PyGstObject_Type)
static PyTypeObject *_PyGstBuffer_Type;
#define PyGstBuffer_Type (*_PyGstBuffer_Type)
static PyTypeObject *_PyGdkPixbuf_Type;
#define PyGdkPixbuf_Type (*_PyGdkPixbuf_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject G_GNUC_INTERNAL PyPgmEvent_Type;
PyTypeObject G_GNUC_INTERNAL PyPgmCanvas_Type;
PyTypeObject G_GNUC_INTERNAL PyPgmDrawable_Type;
PyTypeObject G_GNUC_INTERNAL PyPgmImage_Type;
PyTypeObject G_GNUC_INTERNAL PyPgmText_Type;
PyTypeObject G_GNUC_INTERNAL PyPgmViewport_Type;
PyTypeObject G_GNUC_INTERNAL PyPgmViewportFactory_Type;

#line 75 "./pgm.c"



/* ----------- PgmEvent ----------- */

static int
_wrap_pgm_event_new(PyGBoxed *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "type", NULL };
    PyObject *py_type = NULL;
    PgmEventType type;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmEvent.__init__", kwlist, &py_type))
        return -1;
    if (pyg_enum_get_value(PGM_TYPE_EVENT_TYPE, py_type, (gpointer)&type))
        return -1;
    self->gtype = PGM_TYPE_EVENT;
    self->free_on_dealloc = FALSE;
    self->boxed = pgm_event_new(type);

    if (!self->boxed) {
        PyErr_SetString(PyExc_RuntimeError, "could not create PgmEvent object");
        return -1;
    }
    self->free_on_dealloc = TRUE;
    return 0;
}

static PyObject *
_wrap_pgm_event_copy(PyObject *self)
{
    PgmEvent *ret;

    
    ret = pgm_event_copy(pyg_boxed_get(self, PgmEvent));
    
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(PGM_TYPE_EVENT, ret, TRUE, TRUE);
}

static PyObject *
_wrap_pgm_event_free(PyObject *self)
{
    
    pgm_event_free(pyg_boxed_get(self, PgmEvent));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static const PyMethodDef _PyPgmEvent_methods[] = {
    { "copy", (PyCFunction)_wrap_pgm_event_copy, METH_NOARGS,
      NULL },
    { "free", (PyCFunction)_wrap_pgm_event_free, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

static PyObject *
_wrap_pgm_event__get_type(PyObject *self, void *closure)
{
    gint ret;

    ret = pyg_boxed_get(self, PgmEvent)->type;
    return pyg_enum_from_gtype(PGM_TYPE_EVENT_TYPE, ret);
}

static const PyGetSetDef pgm_event_getsets[] = {
    { "type", (getter)_wrap_pgm_event__get_type, (setter)0 },
    { NULL, (getter)0, (setter)0 },
};

#line 212 "pgmevent.override"
PyObject *
_wrap_pgm_event_tp_getattr (PyObject *self,
                            char *attr)
{
  PgmEvent *event = pyg_boxed_get (self, PgmEvent);

  switch (event->type)
    {
    case PGM_MOTION_NOTIFY:
      if (!strcmp (attr, "__members__"))
        return Py_BuildValue ("[ssss]", "type", "time", "x", "y");
      else if (!strcmp (attr, "time"))
        return PyInt_FromLong (event->motion.time);
      else if (!strcmp (attr, "x"))
        return PyInt_FromLong (event->motion.x);
      else if (!strcmp (attr, "y"))
        return PyInt_FromLong (event->motion.y);
      break;

    case PGM_BUTTON_PRESS:
    case PGM_DOUBLE_BUTTON_PRESS:
    case PGM_TRIPLE_BUTTON_PRESS:
    case PGM_BUTTON_RELEASE:
      if (!strcmp (attr, "__members__"))
        return Py_BuildValue ("[sssss]", "type", "time", "x", "y", "button");
      else if (!strcmp (attr, "time"))
        return PyInt_FromLong (event->button.time);
      else if (!strcmp (attr, "x"))
        return PyInt_FromLong (event->button.x);
      else if (!strcmp (attr, "y"))
        return PyInt_FromLong (event->button.y);
      else if (!strcmp (attr, "button"))
        return pyg_flags_from_gtype (PGM_TYPE_BUTTON_TYPE,
                                     event->button.button);
      break;

    case PGM_SCROLL:
      if (!strcmp (attr, "__members__"))
        return Py_BuildValue ("[sssSS]", "type", "time", "x", "y",
                              "direction");
      else if (!strcmp (attr, "time"))
        return PyInt_FromLong (event->scroll.time);
      else if (!strcmp (attr, "x"))
        return PyInt_FromLong (event->scroll.x);
      else if (!strcmp (attr, "y"))
        return PyInt_FromLong (event->scroll.y);
      else if (!strcmp (attr, "direction"))
        return pyg_enum_from_gtype (PGM_TYPE_SCROLL_DIRECTION,
                                    event->scroll.direction);
      break;

    case PGM_KEY_PRESS:
    case PGM_KEY_RELEASE:
      if (!strcmp (attr, "__members__"))
        return Py_BuildValue ("[sssss]", "type", "time", "modifier", "keyval",
                              "hardware_keycode");
      else if (!strcmp (attr, "time"))
        return PyInt_FromLong (event->key.time);
      else if (!strcmp (attr, "modifier"))
        return pyg_flags_from_gtype (PGM_TYPE_MODIFIER_TYPE,
                                     event->key.modifier);
      else if (!strcmp (attr, "keyval"))
        return PyInt_FromLong (event->key.keyval);
      else if (!strcmp (attr, "hardware_keycode"))
        return PyInt_FromLong (event->key.hardware_keycode);
      break;

    case PGM_CONFIGURE:
      if (!strcmp (attr, "__members__"))
        return Py_BuildValue ("[sssss]", "type", "width", "height", "x", "y");
      else if (!strcmp (attr, "width"))
        return PyInt_FromLong (event->configure.width);
      else if (!strcmp (attr, "height"))
        return PyInt_FromLong (event->configure.height);
      else if (!strcmp (attr, "x"))
        return PyInt_FromLong (event->configure.x);
      else if (!strcmp (attr, "y"))
        return PyInt_FromLong (event->configure.y);
      break;

    default:
      break;
    }

  if (!strcmp (attr, "type"))
    return pyg_enum_from_gtype (PGM_TYPE_EVENT_TYPE, event->type);
  else if (!strcmp (attr, "source"))
    return PyInt_FromLong (event->any.source);
  else
    return PyInt_FromLong (0);
}
#line 240 "./pgm.c"


#line 30 "pgmevent.override"
#define CHECK_VALUE_IS_INT(a,v) \
  G_STMT_START { if (!PyInt_Check ((v))) {                              \
      PyErr_Format (PyExc_TypeError, "%s must be an int", (a));         \
      return -1;                                                        \
    } }G_STMT_END
static int
_wrap_pgm_event_tp_setattr (PyObject *self,
                            gchar *attr,
                            PyObject *value)
{
  PgmEvent *event;

  if (value == NULL)
    {
      PyErr_SetString (PyExc_TypeError, "can't delete attributes");
      return -1;
    }

  event = pyg_boxed_get (self, PgmEvent);

  /* common members */
  if (attr[0] == 't' && !strcmp (attr, "type"))
    {
      PyErr_SetString (PyExc_AttributeError, "type is not writable");
      return -1;
    }
  else if (attr[0] == 's' && !strcmp (attr, "source"))
    {
      CHECK_VALUE_IS_INT (attr, value);
      event->any.source = PyInt_AsLong (value);
      return 0;
    }

  switch (event->type)
    {
    case PGM_NOTHING:
      break;

    case PGM_MOTION_NOTIFY:
      if (!strcmp (attr, "time"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->motion.time = PyInt_AsLong (value);
          return 0;
        }
      else if (attr[0] == 'x' && attr[1] == '\0')
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->motion.x = PyInt_AsLong (value);
          return 0;
        }
      else if (attr[0] == 'y' && attr[1] == '\0')
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->motion.y = PyInt_AsLong (value);
          return 0;
        }
      break;

    case PGM_BUTTON_PRESS:
    case PGM_DOUBLE_BUTTON_PRESS:
    case PGM_TRIPLE_BUTTON_PRESS:
    case PGM_BUTTON_RELEASE:
      if (!strcmp (attr, "time"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->button.time = PyInt_AsLong (value);
          return 0;
        }
      else if (attr[0] == 'x' && attr[1] == '\0')
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->button.x = PyInt_AsLong (value);
          return 0;
        }
      else if (attr[0] == 'y' && attr[1] == '\0')
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->button.y = PyInt_AsLong (value);
          return 0;
        }
      else if (!strcmp (attr, "button"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->button.button = PyInt_AsLong (value);
          return 0;
        }
      break;

    case PGM_KEY_PRESS:
    case PGM_KEY_RELEASE:
      if (!strcmp (attr, "time"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->key.time = PyInt_AsLong (value);
          return 0;
        }
      else if (!strcmp (attr, "modifier"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->key.modifier = PyInt_AsLong (value);
          return 0;
        }
      else if (!strcmp (attr, "keyval"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->key.keyval = PyInt_AsLong (value);
          return 0;
        }
      else if (!strcmp (attr, "hardware_keycode"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->key.hardware_keycode = PyInt_AsLong (value);
          return 0;
        }
      break;

    case PGM_SCROLL:
      if (!strcmp (attr, "time"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->scroll.time = PyInt_AsLong (value);
          return 0;
        }
      else if (attr[0] == 'x' && attr[1] == '\0')
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->scroll.x = PyInt_AsLong (value);
          return 0;
        }
      else if (attr[0] == 'y' && attr[1] == '\0')
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->scroll.y = PyInt_AsLong (value);
          return 0;
        }
      else if (!strcmp (attr, "direction"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->scroll.direction = PyInt_AsLong (value);
          return 0;
        }
      break;

    case PGM_CONFIGURE:
      if (!strcmp (attr, "width"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->configure.width = PyInt_AsLong (value);
          return 0;
        }
      else if (!strcmp (attr, "height"))
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->configure.height = PyInt_AsLong (value);
          return 0;
        }
      else if (attr[0] == 'x' && attr[1] == '\0')
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->configure.x = PyInt_AsLong (value);
          return 0;
        }
      else if (attr[0] == 'y' && attr[1] == '\0')
        {
          CHECK_VALUE_IS_INT (attr, value);
          event->configure.y = PyInt_AsLong (value);
          return 0;
        }
      break;

    default:
      break;
    }

  PyErr_SetString (PyExc_AttributeError, "could not write attribute");
  return -1;
}
#undef CHECK_VALUE_IS_INT

#line 424 "./pgm.c"


PyTypeObject G_GNUC_INTERNAL PyPgmEvent_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "pgm.Event",                   /* tp_name */
    sizeof(PyGBoxed),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)_wrap_pgm_event_tp_getattr,       /* tp_getattr */
    (setattrfunc)_wrap_pgm_event_tp_setattr,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyPgmEvent_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)pgm_event_getsets,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)_wrap_pgm_event_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PgmCanvas ----------- */

static int
_wrap_pgm_canvas_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char* kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     ":pgm.Canvas.__init__",
                                     kwlist))
        return -1;

    pygobject_constructv(self, 0, NULL);
    if (!self->obj) {
        PyErr_SetString(
            PyExc_RuntimeError, 
            "could not create pgm.Canvas object");
        return -1;
    }
    return 0;
}

static PyObject *
_wrap_pgm_canvas_set_size(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "width", "height", NULL };
    double width, height;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dd:PgmCanvas.set_size", kwlist, &width, &height))
        return NULL;
    
    ret = pgm_canvas_set_size(PGM_CANVAS(self->obj), width, height);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 215 "pgmcanvas.override"
static PyObject *
_wrap_pgm_canvas_get_size (PyGObject *self)
{
  gfloat width, height;
  PyObject *py_tuple = NULL;

  pgm_canvas_get_size (PGM_CANVAS (self->obj), &width, &height);

  py_tuple = PyTuple_New (2);
  PyTuple_SetItem (py_tuple, 0, PyFloat_FromDouble (width));
  PyTuple_SetItem (py_tuple, 1, PyFloat_FromDouble (height));

  return py_tuple;
}

#line 527 "./pgm.c"


#line 133 "pgmcanvas.override"
static PyObject *
_wrap_pgm_canvas_add (PyGObject *self,
                      PyObject *args)
{
  gint i, len;
  PgmDrawableLayer layer;
  PyGObject *drawable;
  PgmError added;

  len = PyTuple_Size (args);
  if (len < 2)
    {
      PyErr_SetString (PyExc_TypeError,
                       "PgmCanvas.add_many requires at least two arguments");
      return NULL;
    }

  if (pyg_enum_get_value (PGM_TYPE_DRAWABLE_LAYER, PyTuple_GetItem (args, 0),
                          (gpointer) &layer))
    return NULL;

  for (i = 1; i < len; i++)
    {
      drawable = (PyGObject *) PyTuple_GetItem (args, i);
      if (!pygobject_check (drawable, &PyPgmDrawable_Type))
        {
          PyErr_SetString (PyExc_TypeError, "argument must be a Drawable");
          return NULL;
        }
    }

  for (i = 1; i < len; i++)
    {
      drawable = (PyGObject *) PyTuple_GetItem (args, i);
      added = pgm_canvas_add (PGM_CANVAS (self->obj), layer,
                              PGM_DRAWABLE (drawable->obj));
    }

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, added);
}

#line 572 "./pgm.c"


#line 176 "pgmcanvas.override"
static PyObject *
_wrap_pgm_canvas_remove (PyGObject *self,
                         PyObject *args)
{
  gint i, len;
  PyGObject *drawable;
  PgmError removed;

  len = PyTuple_Size (args);
  if (len < 1)
    {
      PyErr_SetString (PyExc_TypeError,
                       "PgmCanvas.remove_many requires at least one argument");
      return NULL;
    }

  for (i = 0; i < len; i++)
    {
      drawable = (PyGObject*) PyTuple_GetItem (args, i);
      if (!pygobject_check (drawable, &PyPgmDrawable_Type))
        {
          PyErr_SetString (PyExc_TypeError, "argument must be a Drawable");
          return NULL;
        }
    }

  for (i = 0; i < len; i++)
    {
      drawable = (PyGObject*) PyTuple_GetItem (args, i);
      removed = pgm_canvas_remove (PGM_CANVAS (self->obj),
                                   PGM_DRAWABLE (drawable->obj));
    }

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, removed);
}


#line 613 "./pgm.c"


static PyObject *
_wrap_pgm_canvas_set_order(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "drawable", "order", NULL };
    PyGObject *drawable;
    int order;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!i:PgmCanvas.set_order", kwlist, &PyPgmDrawable_Type, &drawable, &order))
        return NULL;
    
    ret = pgm_canvas_set_order(PGM_CANVAS(self->obj), PGM_DRAWABLE(drawable->obj), order);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 232 "pgmcanvas.override"
static PyObject *
_wrap_pgm_canvas_get_order (PyGObject *self, PyObject *args)
{
  PyObject *py_tuple = NULL;
  PgmDrawableLayer layer;
  PyGObject *drawable;
  PgmError ret;
  gint order;

  drawable = (PyGObject*) PyTuple_GetItem (args, 0);
  if (!pygobject_check (drawable, &PyPgmDrawable_Type))
    {
      PyErr_SetString (PyExc_TypeError, "argument must be a Drawable");
      return NULL;
    }

  ret = pgm_canvas_get_order (PGM_CANVAS (self->obj),
                              PGM_DRAWABLE(drawable->obj), &layer, &order);

  py_tuple = PyTuple_New (2);
  PyTuple_SetItem (py_tuple, 0,
                   pyg_enum_from_gtype (PGM_TYPE_DRAWABLE_LAYER, layer));
  PyTuple_SetItem (py_tuple, 1, PyInt_FromLong (order));

  return py_tuple;
}

#line 660 "./pgm.c"


#line 261 "pgmcanvas.override"
static PyObject *
_wrap_pgm_canvas_get_layer_count (PyGObject *self,
                                  PyObject *args)
{
  PyObject *py_tuple = NULL;
  PgmDrawableLayer layer;
  PgmError ret;
  gint count = 0;

  if (pyg_flags_get_value (PGM_TYPE_DRAWABLE_LAYER,
                           PyTuple_GetItem (args, 0), (gpointer) &layer))
    return NULL;

  ret = pgm_canvas_get_layer_count (PGM_CANVAS (self->obj), layer, &count);

  return PyInt_FromLong (count);
}

#line 682 "./pgm.c"


static PyObject *
_wrap_pgm_canvas_regenerate(PyGObject *self)
{
    gint ret;

    
    ret = pgm_canvas_regenerate(PGM_CANVAS(self->obj));
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 281 "pgmcanvas.override"
static PyObject *
_wrap_pgm_canvas_get_pixel_formats (PyGObject *self)
{
  PyObject *py_tuple = NULL;
  gulong mask = 0;
  guint size = 0;
  guint i;

  pgm_canvas_get_pixel_formats (PGM_CANVAS (self->obj), &mask);

  /* Get the size */
  for (i = 0; i < PGM_IMAGE_NB_PIXEL_FORMATS; i++)
    {
      if (mask & (1 << i))
        size++;
    }

  /* Build the tuple */
  py_tuple = PyTuple_New (size);

  /* And fill it */
  size = 0;
  for (i = 0; i < PGM_IMAGE_NB_PIXEL_FORMATS; i++)
    {
      if (mask & (1 << i))
        {
          PyTuple_SetItem (py_tuple, size,
                           pyg_flags_from_gtype (PGM_TYPE_IMAGE_PIXEL_FORMAT,
                                                 mask & (1 << i)));
          size++;
        }
    }

  return py_tuple;
}
#line 732 "./pgm.c"


static const PyMethodDef _PyPgmCanvas_methods[] = {
    { "set_size", (PyCFunction)_wrap_pgm_canvas_set_size, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_size", (PyCFunction)_wrap_pgm_canvas_get_size, METH_NOARGS,
      NULL },
    { "add", (PyCFunction)_wrap_pgm_canvas_add, METH_VARARGS,
      NULL },
    { "remove", (PyCFunction)_wrap_pgm_canvas_remove, METH_VARARGS,
      NULL },
    { "set_order", (PyCFunction)_wrap_pgm_canvas_set_order, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_order", (PyCFunction)_wrap_pgm_canvas_get_order, METH_VARARGS,
      NULL },
    { "get_layer_count", (PyCFunction)_wrap_pgm_canvas_get_layer_count, METH_VARARGS,
      NULL },
    { "regenerate", (PyCFunction)_wrap_pgm_canvas_regenerate, METH_NOARGS,
      NULL },
    { "get_pixel_formats", (PyCFunction)_wrap_pgm_canvas_get_pixel_formats, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

#line 30 "pgmcanvas.override"
static PyObject *
_wrap_pgm_canvas__get_size (PyGObject *self,
                            void *closure)
{
  return _wrap_pgm_canvas_get_size (self);
}

static int
_wrap_pgm_canvas__set_size (PyGObject *self,
                            PyObject *value,
                            void *closure)
{
  PyObject *object;
  gfloat width, height;

  object = PyTuple_GetItem (value, 0);
  width = PyFloat_AsDouble (object);
  object = PyTuple_GetItem (value, 1);
  height = PyFloat_AsDouble (object);

  if (PyErr_Occurred ())
    return -1;

  pgm_canvas_set_size (PGM_CANVAS (self->obj), width, height);

  return 0;
}

#line 786 "./pgm.c"


#line 60 "pgmcanvas.override"
static PyObject *
_wrap_pgm_canvas__get_width (PyGObject *self,
                             void *closure)
{
  gfloat width, height;

  pgm_canvas_get_size (PGM_CANVAS (self->obj), &width, &height);

  return PyFloat_FromDouble (width);
}

static int
_wrap_pgm_canvas__set_width (PyGObject *self,
                             PyObject *value,
                             void *closure)
{
  gfloat width, _width, height;

  _width = PyFloat_AsDouble (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_canvas_get_size (PGM_CANVAS (self->obj), &width, &height);
  pgm_canvas_set_size (PGM_CANVAS (self->obj), _width, height);

  return 0;
}

#line 819 "./pgm.c"


#line 91 "pgmcanvas.override"
static PyObject *
_wrap_pgm_canvas__get_height (PyGObject *self,
                              void *closure)
{
  gfloat width, height;

  pgm_canvas_get_size (PGM_CANVAS (self->obj), &width, &height);

  return PyFloat_FromDouble (height);
}

static int
_wrap_pgm_canvas__set_height (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  gfloat width, height, _height;

  _height = PyFloat_AsDouble (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_canvas_get_size (PGM_CANVAS (self->obj), &width, &height);
  pgm_canvas_set_size (PGM_CANVAS (self->obj), width, _height);

  return 0;
}

#line 852 "./pgm.c"


#line 122 "pgmcanvas.override"
static PyObject *
_wrap_pgm_canvas__get_pixel_formats (PyGObject *self,
                                     void *closure)
{
  return _wrap_pgm_canvas_get_pixel_formats (self);
}

/* Methods override */

#line 865 "./pgm.c"


static const PyGetSetDef pgm_canvas_getsets[] = {
    { "size", (getter)_wrap_pgm_canvas__get_size, (setter)_wrap_pgm_canvas__set_size },
    { "width", (getter)_wrap_pgm_canvas__get_width, (setter)_wrap_pgm_canvas__set_width },
    { "height", (getter)_wrap_pgm_canvas__get_height, (setter)_wrap_pgm_canvas__set_height },
    { "pixel_formats", (getter)_wrap_pgm_canvas__get_pixel_formats, (setter)0 },
    { NULL, (getter)0, (setter)0 },
};

PyTypeObject G_GNUC_INTERNAL PyPgmCanvas_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "pgm.Canvas",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyPgmCanvas_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)pgm_canvas_getsets,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_pgm_canvas_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PgmDrawable ----------- */

static PyObject *
_wrap_pgm_drawable_hide(PyGObject *self)
{
    gint ret;

    
    ret = pgm_drawable_hide(PGM_DRAWABLE(self->obj));
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

static PyObject *
_wrap_pgm_drawable_show(PyGObject *self)
{
    gint ret;

    
    ret = pgm_drawable_show(PGM_DRAWABLE(self->obj));
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 633 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable_is_visible (PyGObject *self)
{
  gboolean visible;

  pgm_drawable_is_visible (PGM_DRAWABLE (self->obj), &visible);

  return PyBool_FromLong (visible);
}


#line 959 "./pgm.c"


static PyObject *
_wrap_pgm_drawable_set_size(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "width", "height", NULL };
    double width, height;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dd:PgmDrawable.set_size", kwlist, &width, &height))
        return NULL;
    
    ret = pgm_drawable_set_size(PGM_DRAWABLE(self->obj), width, height);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 646 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable_get_size (PyGObject *self)
{
  gfloat width, height;
  PyObject *py_tuple = NULL;

  pgm_drawable_get_size (PGM_DRAWABLE (self->obj), &width, &height);

  py_tuple = PyTuple_New (2);
  PyTuple_SetItem (py_tuple, 0, PyFloat_FromDouble (width));
  PyTuple_SetItem (py_tuple, 1, PyFloat_FromDouble (height));

  return py_tuple;
}

#line 993 "./pgm.c"


static PyObject *
_wrap_pgm_drawable_set_position(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", "z", NULL };
    double x, y, z;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ddd:PgmDrawable.set_position", kwlist, &x, &y, &z))
        return NULL;
    
    ret = pgm_drawable_set_position(PGM_DRAWABLE(self->obj), x, y, z);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 663 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable_get_position (PyGObject *self)
{
  gfloat x, y, z;
  PyObject *py_tuple = NULL;

  pgm_drawable_get_position (PGM_DRAWABLE (self->obj), &x, &y, &z);

  py_tuple = PyTuple_New (3);
  PyTuple_SetItem (py_tuple, 0, PyFloat_FromDouble (x));
  PyTuple_SetItem (py_tuple, 1, PyFloat_FromDouble (y));
  PyTuple_SetItem (py_tuple, 2, PyFloat_FromDouble (z));

  return py_tuple;
}

#line 1028 "./pgm.c"


#line 681 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable_set_fg_color (PyGObject *self,
                                 PyObject *args,
                                 PyObject *kwargs)
{
  static char *kwlist[] = { "r", "g", "b", "a", NULL };
  gint r, g, b, a;
  gint ret;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "iiii", kwlist, &r, &g, &b,
                                    &a))
    return NULL;

  ret = pgm_drawable_set_fg_color (PGM_DRAWABLE (self->obj), (guchar) r,
                                   (guchar) g, (guchar) b, (guchar) a);

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, ret);
}

#line 1051 "./pgm.c"


#line 702 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable_get_fg_color (PyGObject *self)
{
  guchar r, g, b, a;
  PyObject *py_tuple = NULL;

  pgm_drawable_get_fg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);

  py_tuple = PyTuple_New (4);
  PyTuple_SetItem (py_tuple, 0, PyInt_FromLong ((long) r));
  PyTuple_SetItem (py_tuple, 1, PyInt_FromLong ((long) g));
  PyTuple_SetItem (py_tuple, 2, PyInt_FromLong ((long) b));
  PyTuple_SetItem (py_tuple, 3, PyInt_FromLong ((long) a));

  return py_tuple;
}

#line 1072 "./pgm.c"


#line 721 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable_set_bg_color (PyGObject *self,
                                 PyObject *args,
                                 PyObject *kwargs)
{
  static char *kwlist[] = { "r", "g", "b", "a", NULL };
  gint r, g, b, a;
  gint ret;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "iiii", kwlist, &r, &g, &b,
                                    &a))
    return NULL;

  ret = pgm_drawable_set_bg_color (PGM_DRAWABLE (self->obj), (guchar) r,
                                   (guchar) g, (guchar) b, (guchar) a);

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, ret);
}

#line 1095 "./pgm.c"


#line 742 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable_get_bg_color (PyGObject *self)
{
  guchar r, g, b, a;
  PyObject *py_tuple = NULL;

  pgm_drawable_get_bg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);

  py_tuple = PyTuple_New (4);
  PyTuple_SetItem (py_tuple, 0, PyInt_FromLong ((long) r));
  PyTuple_SetItem (py_tuple, 1, PyInt_FromLong ((long) g));
  PyTuple_SetItem (py_tuple, 2, PyInt_FromLong ((long) b));
  PyTuple_SetItem (py_tuple, 3, PyInt_FromLong ((long) a));

  return py_tuple;
}

#line 1116 "./pgm.c"


#line 761 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable_set_opacity (PyGObject *self,
                                PyObject *args,
                                PyObject *kwargs)
{
  static char *kwlist[] = { "opacity", NULL };
  gint opacity;
  gint ret;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "i", kwlist, &opacity))
    return NULL;

  ret = pgm_drawable_set_opacity (PGM_DRAWABLE (self->obj), (guchar) opacity);

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, ret);
}

#line 1137 "./pgm.c"


#line 780 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable_get_opacity (PyGObject *self)
{
  guchar opacity;

  pgm_drawable_get_opacity (PGM_DRAWABLE (self->obj), &opacity);

  return PyInt_FromLong ((long) opacity);
}
#line 1150 "./pgm.c"


static const PyMethodDef _PyPgmDrawable_methods[] = {
    { "hide", (PyCFunction)_wrap_pgm_drawable_hide, METH_NOARGS,
      NULL },
    { "show", (PyCFunction)_wrap_pgm_drawable_show, METH_NOARGS,
      NULL },
    { "is_visible", (PyCFunction)_wrap_pgm_drawable_is_visible, METH_NOARGS,
      NULL },
    { "set_size", (PyCFunction)_wrap_pgm_drawable_set_size, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_size", (PyCFunction)_wrap_pgm_drawable_get_size, METH_NOARGS,
      NULL },
    { "set_position", (PyCFunction)_wrap_pgm_drawable_set_position, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_position", (PyCFunction)_wrap_pgm_drawable_get_position, METH_NOARGS,
      NULL },
    { "set_fg_color", (PyCFunction)_wrap_pgm_drawable_set_fg_color, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_fg_color", (PyCFunction)_wrap_pgm_drawable_get_fg_color, METH_NOARGS,
      NULL },
    { "set_bg_color", (PyCFunction)_wrap_pgm_drawable_set_bg_color, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_bg_color", (PyCFunction)_wrap_pgm_drawable_get_bg_color, METH_NOARGS,
      NULL },
    { "set_opacity", (PyCFunction)_wrap_pgm_drawable_set_opacity, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_opacity", (PyCFunction)_wrap_pgm_drawable_get_opacity, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

#line 30 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_visible (PyGObject *self,
                                 void *closure)
{
  gboolean visible;

  pgm_drawable_is_visible (PGM_DRAWABLE (self->obj), &visible);

  if (visible)
    Py_RETURN_TRUE;
  else
    Py_RETURN_FALSE;
}

static int
_wrap_pgm_drawable__set_visible (PyGObject *self,
                                 PyObject *value,
                                 void *closure)
{
  gint show;

  if (!PyBool_Check (value))
    {
      PyErr_SetString (PyExc_TypeError, "a boolean is required");
      return -1;
    }

  show = PyInt_AsLong (value);
  if (show)
    pgm_drawable_show (PGM_DRAWABLE (self->obj));
  else
    pgm_drawable_hide (PGM_DRAWABLE (self->obj));

  return 0;
}

#line 1220 "./pgm.c"


#line 68 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_size (PyGObject *self,
                              void *closure)
{
  return _wrap_pgm_drawable_get_size (self);
}

static int
_wrap_pgm_drawable__set_size (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  PyObject *object;
  gfloat width, height;

  object = PyTuple_GetItem (value, 0);
  width = PyFloat_AsDouble (object);
  object = PyTuple_GetItem (value, 1);
  height = PyFloat_AsDouble (object);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_set_size (PGM_DRAWABLE (self->obj), width, height);

  return 0;
}

#line 1252 "./pgm.c"


#line 98 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_width (PyGObject *self,
                               void *closure)
{
  gfloat width, height;

  pgm_drawable_get_size (PGM_DRAWABLE (self->obj), &width, &height);

  return PyFloat_FromDouble (width);
}

static int
_wrap_pgm_drawable__set_width (PyGObject *self,
                               PyObject *value,
                               void *closure)
{
  gfloat width, _width, height;

  _width = PyFloat_AsDouble (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_size (PGM_DRAWABLE (self->obj), &width, &height);
  pgm_drawable_set_size (PGM_DRAWABLE (self->obj), _width, height);

  return 0;
}

#line 1285 "./pgm.c"


#line 129 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_height (PyGObject *self,
                                void *closure)
{
  gfloat width, height;

  pgm_drawable_get_size (PGM_DRAWABLE (self->obj), &width, &height);

  return PyFloat_FromDouble (height);
}

static int
_wrap_pgm_drawable__set_height (PyGObject *self,
                                PyObject *value,
                                void *closure)
{
  gfloat width, height, _height;

  _height = PyFloat_AsDouble (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_size (PGM_DRAWABLE (self->obj), &width, &height);
  pgm_drawable_set_size (PGM_DRAWABLE (self->obj), width, _height);

  return 0;
}

#line 1318 "./pgm.c"


#line 160 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_position (PyGObject *self,
                                  void *closure)
{
  return _wrap_pgm_drawable_get_position (self);
}

static int
_wrap_pgm_drawable__set_position (PyGObject *self,
                                  PyObject *value,
                                  void *closure)
{
  PyObject *object;
  gfloat x, y, z;

  object = PyTuple_GetItem (value, 0);
  x = PyFloat_AsDouble (object);
  object = PyTuple_GetItem (value, 1);
  y = PyFloat_AsDouble (object);
  object = PyTuple_GetItem (value, 2);
  z = PyFloat_AsDouble (object);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_set_position (PGM_DRAWABLE (self->obj), x, y, z);

  return 0;
}

#line 1352 "./pgm.c"


#line 192 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_x (PyGObject *self,
                           void *closure)
{
  gfloat x, y, z;

  pgm_drawable_get_position (PGM_DRAWABLE (self->obj), &x, &y, &z);

  return PyFloat_FromDouble (x);
}

static int
_wrap_pgm_drawable__set_x (PyGObject *self,
                           PyObject *value,
                           void *closure)
{
  gfloat x, _x, y, z;

  _x = PyFloat_AsDouble (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_position (PGM_DRAWABLE (self->obj), &x, &y, &z);
  pgm_drawable_set_position (PGM_DRAWABLE (self->obj), _x, y, z);

  return 0;
}

#line 1385 "./pgm.c"


#line 223 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_y (PyGObject *self,
                           void *closure)
{
  gfloat x, y, z;

  pgm_drawable_get_position (PGM_DRAWABLE (self->obj), &x, &y, &z);

  return PyFloat_FromDouble (y);
}

static int
_wrap_pgm_drawable__set_y (PyGObject *self,
                           PyObject *value,
                           void *closure)
{
  gfloat x, y, _y, z;

  _y = PyFloat_AsDouble (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_position (PGM_DRAWABLE (self->obj), &x, &y, &z);
  pgm_drawable_set_position (PGM_DRAWABLE (self->obj), x, _y, z);

  return 0;
}

#line 1418 "./pgm.c"


#line 254 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_z (PyGObject *self,
                           void *closure)
{
  gfloat x, y, z;

  pgm_drawable_get_position (PGM_DRAWABLE (self->obj), &x, &y, &z);

  return PyFloat_FromDouble (z);
}

static int
_wrap_pgm_drawable__set_z (PyGObject *self,
                           PyObject *value,
                           void *closure)
{
  gfloat x, y, z, _z;

  _z = PyFloat_AsDouble (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_position (PGM_DRAWABLE (self->obj), &x, &y, &z);
  pgm_drawable_set_position (PGM_DRAWABLE (self->obj), x, y, _z);

  return 0;
}

#line 1451 "./pgm.c"


#line 285 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_fg_color (PyGObject *self,
                                  void *closure)
{
  return _wrap_pgm_drawable_get_fg_color (self);
}

static int
_wrap_pgm_drawable__set_fg_color (PyGObject *self,
                                  PyObject *value,
                                  void *closure)
{
  PyObject *object;
  guchar r, g, b, a;

  object = PyTuple_GetItem (value, 0);
  r = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);
  object = PyTuple_GetItem (value, 1);
  g = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);
  object = PyTuple_GetItem (value, 2);
  b = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);
  object = PyTuple_GetItem (value, 3);
  a = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_set_fg_color (PGM_DRAWABLE (self->obj), r, g, b, a);

  return 0;
}

#line 1487 "./pgm.c"


#line 319 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_fg_r (PyGObject *self,
                              void *closure)
{
  guchar r, g, b, a;

  pgm_drawable_get_fg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (r);
}

static int
_wrap_pgm_drawable__set_fg_r (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  guchar r, _r, g, b, a;

  _r = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_fg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);
  pgm_drawable_set_fg_color (PGM_DRAWABLE (self->obj), _r, g, b, a);

  return 0;
}

#line 1520 "./pgm.c"


#line 350 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_fg_g (PyGObject *self,
                              void *closure)
{
  guchar r, g, b, a;

  pgm_drawable_get_fg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (g);
}

static int
_wrap_pgm_drawable__set_fg_g (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  guchar r, g, _g, b, a;

  _g = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_fg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);
  pgm_drawable_set_fg_color (PGM_DRAWABLE (self->obj), r, _g, b, a);

  return 0;
}

#line 1553 "./pgm.c"


#line 381 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_fg_b (PyGObject *self,
                              void *closure)
{
  guchar r, g, b, a;

  pgm_drawable_get_fg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (b);
}

static int
_wrap_pgm_drawable__set_fg_b (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  guchar r, g, b, _b, a;

  _b = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_fg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);
  pgm_drawable_set_fg_color (PGM_DRAWABLE (self->obj), r, g, _b, a);

  return 0;
}

#line 1586 "./pgm.c"


#line 412 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_fg_a (PyGObject *self,
                              void *closure)
{
  guchar r, g, b, a;

  pgm_drawable_get_fg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (a);
}

static int
_wrap_pgm_drawable__set_fg_a (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  guchar r, g, b, a, _a;

  _a = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_fg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);
  pgm_drawable_set_fg_color (PGM_DRAWABLE (self->obj), r, g, b, _a);

  return 0;
}

#line 1619 "./pgm.c"


#line 443 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_bg_color (PyGObject *self,
                                  void *closure)
{
  return _wrap_pgm_drawable_get_bg_color (self);
}

static int
_wrap_pgm_drawable__set_bg_color (PyGObject *self,
                                  PyObject *value,
                                  void *closure)
{
  PyObject *object;
  guchar r, g, b, a;

  object = PyTuple_GetItem (value, 0);
  r = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);
  object = PyTuple_GetItem (value, 1);
  g = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);
  object = PyTuple_GetItem (value, 2);
  b = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);
  object = PyTuple_GetItem (value, 3);
  a = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_set_bg_color (PGM_DRAWABLE (self->obj), r, g, b, a);

  return 0;
}

#line 1655 "./pgm.c"


#line 477 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_bg_r (PyGObject *self,
                              void *closure)
{
  guchar r, g, b, a;

  pgm_drawable_get_bg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (r);
}

static int
_wrap_pgm_drawable__set_bg_r (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  guchar r, _r, g, b, a;

  _r = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_bg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);
  pgm_drawable_set_bg_color (PGM_DRAWABLE (self->obj), _r, g, b, a);

  return 0;
}

#line 1688 "./pgm.c"


#line 508 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_bg_g (PyGObject *self,
                              void *closure)
{
  guchar r, g, b, a;

  pgm_drawable_get_bg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (g);
}

static int
_wrap_pgm_drawable__set_bg_g (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  guchar r, g, _g, b, a;

  _g = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_bg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);
  pgm_drawable_set_bg_color (PGM_DRAWABLE (self->obj), r, _g, b, a);

  return 0;
}

#line 1721 "./pgm.c"


#line 539 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_bg_b (PyGObject *self,
                              void *closure)
{
  guchar r, g, b, a;

  pgm_drawable_get_bg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (b);
}

static int
_wrap_pgm_drawable__set_bg_b (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  guchar r, g, b, _b, a;

  _b = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_bg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);
  pgm_drawable_set_bg_color (PGM_DRAWABLE (self->obj), r, g, _b, a);

  return 0;
}

#line 1754 "./pgm.c"


#line 570 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_bg_a (PyGObject *self,
                              void *closure)
{
  guchar r, g, b, a;

  pgm_drawable_get_bg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (a);
}

static int
_wrap_pgm_drawable__set_bg_a (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  guchar r, g, b, a, _a;

  _a = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_get_bg_color (PGM_DRAWABLE (self->obj), &r, &g, &b, &a);
  pgm_drawable_set_bg_color (PGM_DRAWABLE (self->obj), r, g, b, _a);

  return 0;
}

#line 1787 "./pgm.c"


#line 601 "pgmdrawable.override"
static PyObject *
_wrap_pgm_drawable__get_opacity (PyGObject *self,
                                 void *closure)
{
  guchar opacity;

  pgm_drawable_get_opacity (PGM_DRAWABLE (self->obj), &opacity);

  return PyInt_FromLong (opacity);
}

static int
_wrap_pgm_drawable__set_opacity (PyGObject *self,
                                 PyObject *value,
                                 void *closure)
{
  guchar opacity;

  opacity = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_drawable_set_opacity (PGM_DRAWABLE (self->obj), opacity);

  return 0;
}

/* Methods override */

#line 1821 "./pgm.c"


static const PyGetSetDef pgm_drawable_getsets[] = {
    { "visible", (getter)_wrap_pgm_drawable__get_visible, (setter)_wrap_pgm_drawable__set_visible },
    { "size", (getter)_wrap_pgm_drawable__get_size, (setter)_wrap_pgm_drawable__set_size },
    { "width", (getter)_wrap_pgm_drawable__get_width, (setter)_wrap_pgm_drawable__set_width },
    { "height", (getter)_wrap_pgm_drawable__get_height, (setter)_wrap_pgm_drawable__set_height },
    { "position", (getter)_wrap_pgm_drawable__get_position, (setter)_wrap_pgm_drawable__set_position },
    { "x", (getter)_wrap_pgm_drawable__get_x, (setter)_wrap_pgm_drawable__set_x },
    { "y", (getter)_wrap_pgm_drawable__get_y, (setter)_wrap_pgm_drawable__set_y },
    { "z", (getter)_wrap_pgm_drawable__get_z, (setter)_wrap_pgm_drawable__set_z },
    { "fg_color", (getter)_wrap_pgm_drawable__get_fg_color, (setter)_wrap_pgm_drawable__set_fg_color },
    { "fg_r", (getter)_wrap_pgm_drawable__get_fg_r, (setter)_wrap_pgm_drawable__set_fg_r },
    { "fg_g", (getter)_wrap_pgm_drawable__get_fg_g, (setter)_wrap_pgm_drawable__set_fg_g },
    { "fg_b", (getter)_wrap_pgm_drawable__get_fg_b, (setter)_wrap_pgm_drawable__set_fg_b },
    { "fg_a", (getter)_wrap_pgm_drawable__get_fg_a, (setter)_wrap_pgm_drawable__set_fg_a },
    { "bg_color", (getter)_wrap_pgm_drawable__get_bg_color, (setter)_wrap_pgm_drawable__set_bg_color },
    { "bg_r", (getter)_wrap_pgm_drawable__get_bg_r, (setter)_wrap_pgm_drawable__set_bg_r },
    { "bg_g", (getter)_wrap_pgm_drawable__get_bg_g, (setter)_wrap_pgm_drawable__set_bg_g },
    { "bg_b", (getter)_wrap_pgm_drawable__get_bg_b, (setter)_wrap_pgm_drawable__set_bg_b },
    { "bg_a", (getter)_wrap_pgm_drawable__get_bg_a, (setter)_wrap_pgm_drawable__set_bg_a },
    { "opacity", (getter)_wrap_pgm_drawable__get_opacity, (setter)_wrap_pgm_drawable__set_opacity },
    { NULL, (getter)0, (setter)0 },
};

PyTypeObject G_GNUC_INTERNAL PyPgmDrawable_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "pgm.Drawable",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyPgmDrawable_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)pgm_drawable_getsets,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PgmImage ----------- */

#line 37 "pgmimage.override"
static int
_wrap_pgm_image_new (PyGObject *self,
                     PyObject *args,
                     PyObject *kwargs)
{
  static char *kwlist[] = { "image", "format", "width", "height", "stride",
                            "size", "data", NULL };
  guint fd, format, width, height, stride, size;
  gconstpointer data = NULL;
  PyGObject* py_img = NULL;
  PyObject *first_arg;

  fd = -1;
  format = -1;
  width = 0;
  height = 0;
  stride = 0;
  size = 0;

  /* FIXME: verily untested! */

  if ((PyTuple_Size (args) == 1) )
    {
      first_arg = PyTuple_GetItem (args, 0);
      if (PyInt_Check (first_arg))
        fd = PyInt_AsLong (first_arg);
      else
        {
          /* if (!PyArg_ParseTuple (args, "I", &fd)) */
          if (!PyArg_ParseTuple (args, "O!", &PyPgmImage_Type, &py_img))
            return -1;
        }
    }
  else
    if ((PyTuple_Size (args) == 6))
      if (!PyArg_ParseTupleAndKeywords (args, kwargs,"iIIIIO", kwlist,
                                        &format, &width, &height, &stride,
                                        &size, &data))
        return -1;

  if (fd > -1)
    self->obj = (GObject *) pgm_image_new_from_fd (fd, 0);
  else
    {
      if (format > -1)
        {
          self->obj = (GObject *) pgm_image_new_from_buffer (format, width,
                                                             height, stride,
                                                             size, data);
        }
      else
        if (py_img)
          self->obj =
            (GObject *) pgm_image_new_from_image (PGM_IMAGE (py_img->obj));
        else
          pygobject_construct (self, NULL);
    }
  if (!self->obj)
    {
      PyErr_SetString (PyExc_RuntimeError, "could not create PgmImage object");
      return -1;
    }

  pygobject_register_wrapper ((PyObject *) self);

  return 0;
}

/* tp_getset override */

#line 1967 "./pgm.c"


#line 507 "pgmimage.override"
static PyObject *
_wrap_pgm_image_set_from_buffer (PyGObject *self,
                                 PyObject *args,
                                 PyObject *kwargs)
{
  static char *kwlist[] =
    { "format", "width", "height", "stride", "size", "data", NULL };
  PyObject *py_format = NULL, *py_width = NULL, *py_height = NULL;
  PyObject *py_stride = NULL, *py_size = NULL, *py_data = NULL;;
  guint width = 0, height = 0, stride = 0, size = 0;
  gconstpointer *data;
  PyObject *str;
  PgmImagePixelFormat format;
  gint ret;
  gint len;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "OOOOOO:PgmImage.set_image_from_buffer",
                                    kwlist, &py_format, &py_width, &py_height,
                                    &py_stride, &py_size, &py_data))
        return NULL;

  if (pyg_enum_get_value (PGM_TYPE_IMAGE_PIXEL_FORMAT, py_format,
                          (gint *) &format))
    return NULL;
  if (py_width)
    {
      if (PyLong_Check (py_width))
        width = PyLong_AsUnsignedLong (py_width);
      else if (PyInt_Check (py_width))
        width = PyInt_AsLong (py_width);
      else
        PyErr_SetString (PyExc_TypeError,
                         "Parameter 'width' must be an int or a long");
      if (PyErr_Occurred ())
        return NULL;
    }
  if (py_height)
    {
      if (PyLong_Check (py_height))
        height = PyLong_AsUnsignedLong (py_height);
      else if (PyInt_Check (py_height))
        height = PyInt_AsLong (py_height);
      else
        PyErr_SetString (PyExc_TypeError,
                         "Parameter 'height' must be an int or a long");
      if (PyErr_Occurred ())
        return NULL;
    }
  if (py_stride)
    {
      if (PyLong_Check (py_stride))
        stride = PyLong_AsUnsignedLong (py_stride);
      else if (PyInt_Check (py_stride))
        stride = PyInt_AsLong (py_stride);
      else
        PyErr_SetString (PyExc_TypeError,
                         "Parameter 'stride' must be an int or a long");
      if (PyErr_Occurred ())
        return NULL;
    }
  if (py_size)
    {
      if (PyLong_Check (py_size))
        size = PyLong_AsUnsignedLong (py_size);
      else if (PyInt_Check (py_size))
        size = PyInt_AsLong (py_size);
      else
        PyErr_SetString (PyExc_TypeError,
                         "Parameter 'size' must be an int or a long");
      if (PyErr_Occurred ())
        return NULL;
    }

  str = PyObject_Str (py_data);
  PyString_AsStringAndSize (str, (char **) &data, &len);
  Py_DECREF (str);

  pyg_begin_allow_threads;
  ret = pgm_image_set_from_buffer (PGM_IMAGE (self->obj), format, width,
                                   height, stride, size, (gconstpointer) data);
  pyg_end_allow_threads;

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, ret);
}

#line 2057 "./pgm.c"


#line 362 "pgmimage.override"
static PyObject *
_wrap_pgm_image_set_from_gst_buffer (PyGObject *self,
                                     PyObject *args,
                                     PyObject *kwargs)
{
  static char *kwlist[] =
    { "format", "width", "height", "stride", "buffer", NULL };
  PyObject *py_format = NULL, *py_width = NULL, *py_height = NULL;
  PyObject *py_stride = NULL;
  PgmImagePixelFormat format;
  gint ret;
  PyGObject *py_buffer;
  GstBuffer *buffer;
  guint width = 0, height = 0, stride = 0;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "OOOOO!:PgmImage.set_image_from_gst_buffer",
                                    kwlist, &py_format, &py_width,
                                    &py_height, &py_stride,
                                    &PyGstBuffer_Type, &py_buffer))
    return NULL;

  if (pyg_enum_get_value (PGM_TYPE_IMAGE_PIXEL_FORMAT, py_format,
                          (gint *) &format))
    return NULL;

  if (py_width)
    {
      if (PyLong_Check (py_width))
        width = PyLong_AsUnsignedLong (py_width);
      else if (PyInt_Check (py_width))
        width = PyInt_AsLong (py_width);
      else
        PyErr_SetString (PyExc_TypeError,
                         "Parameter 'width' must be an int or a long");
      if (PyErr_Occurred ())
        return NULL;
    }
  if (py_height)
    {
      if (PyLong_Check (py_height))
        height = PyLong_AsUnsignedLong (py_height);
      else if (PyInt_Check (py_height))
        height = PyInt_AsLong (py_height);
      else
        PyErr_SetString (PyExc_TypeError,
                         "Parameter 'height' must be an int or a long");
      if (PyErr_Occurred ())
        return NULL;
    }
  if (py_stride)
    {
      if (PyLong_Check (py_stride))
        stride = PyLong_AsUnsignedLong (py_stride);
      else if (PyInt_Check (py_stride))
        stride = PyInt_AsLong (py_stride);
      else
        PyErr_SetString (PyExc_TypeError,
                         "Parameter 'stride' must be an int or a long");
      if (PyErr_Occurred ())
        return NULL;
    }

  pyg_begin_allow_threads;
  buffer = GST_BUFFER (py_buffer->obj);
  ret = pgm_image_set_from_gst_buffer (PGM_IMAGE (self->obj), format, width,
                                       height, stride, buffer);
  pyg_end_allow_threads;

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, ret);
}

#line 2133 "./pgm.c"


#line 595 "pgmimage.override"
static PyObject *
_wrap_pgm_image_set_from_fd(PyGObject *self,
                            PyObject *args,
                            PyObject *kwargs)
{
  static char *kwlist[] = { "fd", "max_size", NULL };
  gint fd;
  PyObject *py_max_size = NULL;
  gint ret;
  guint max_size = 0;

  if ((PyTuple_Size (args) == 2))
    {
      if (!PyArg_ParseTupleAndKeywords (args, kwargs,"iO:PgmImage.set_from_fd",
                                        kwlist, &fd, &py_max_size))
        return NULL;
      if (py_max_size)
        {
          if (PyLong_Check (py_max_size))
            max_size = PyLong_AsUnsignedLong (py_max_size);
          else if (PyInt_Check (py_max_size))
            max_size = PyInt_AsLong (py_max_size);
          else
            PyErr_SetString (PyExc_TypeError,
                             "Parameter 'max_size' must be an int or a long");
          if (PyErr_Occurred ())
            return NULL;
        }
    }
  else
    {
      if (!PyArg_ParseTuple (args, "i:PgmImage.set_from_fd", &fd))
        return NULL;
    }

  ret = pgm_image_set_from_fd (PGM_IMAGE(self->obj), fd, max_size);

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, ret);
}
#line 2176 "./pgm.c"


static PyObject *
_wrap_pgm_image_set_from_image(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "src_image", NULL };
    PyGObject *src_image;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:PgmImage.set_from_image", kwlist, &PyPgmImage_Type, &src_image))
        return NULL;
    
    ret = pgm_image_set_from_image(PGM_IMAGE(self->obj), PGM_IMAGE(src_image->obj));
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

static PyObject *
_wrap_pgm_image_clear(PyGObject *self)
{
    gint ret;

    
    ret = pgm_image_clear(PGM_IMAGE(self->obj));
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 297 "pgmimage.override"
static PyObject *
_wrap_pgm_image_get_storage_type (PyGObject *self)
{
  PgmImageStorageType storage;

  pgm_image_get_storage_type (PGM_IMAGE (self->obj), &storage);

  return pyg_enum_from_gtype (PGM_TYPE_IMAGE_STORAGE_TYPE, storage);
}

#line 2216 "./pgm.c"


static PyObject *
_wrap_pgm_image_set_alignment(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "align", NULL };
    PyObject *py_align = NULL;
    PgmImageAlignment align;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmImage.set_alignment", kwlist, &py_align))
        return NULL;
    if (pyg_flags_get_value(PGM_TYPE_IMAGE_ALIGNMENT, py_align, (gpointer)&align))
        return NULL;
    
    ret = pgm_image_set_alignment(PGM_IMAGE(self->obj), align);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 309 "pgmimage.override"
static PyObject *
_wrap_pgm_image_get_alignment (PyGObject *self)
{
  PgmImageAlignment align;

  pgm_image_get_alignment (PGM_IMAGE (self->obj), &align);

  return pyg_flags_from_gtype (PGM_TYPE_IMAGE_ALIGNMENT, align);
}

#line 2248 "./pgm.c"


static PyObject *
_wrap_pgm_image_set_layout(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "layout", NULL };
    PyObject *py_layout = NULL;
    gint ret;
    PgmImageLayoutType layout;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmImage.set_layout", kwlist, &py_layout))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_IMAGE_LAYOUT_TYPE, py_layout, (gpointer)&layout))
        return NULL;
    
    ret = pgm_image_set_layout(PGM_IMAGE(self->obj), layout);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 321 "pgmimage.override"
static PyObject *
_wrap_pgm_image_get_layout (PyGObject *self)
{
  PgmImageLayoutType layout;

  pgm_image_get_layout (PGM_IMAGE (self->obj), &layout);

  return pyg_enum_from_gtype (PGM_TYPE_IMAGE_LAYOUT_TYPE, layout);
}

#line 2280 "./pgm.c"


static PyObject *
_wrap_pgm_image_set_interp(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "interp", NULL };
    PyObject *py_interp = NULL;
    PgmImageInterpType interp;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmImage.set_interp", kwlist, &py_interp))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_IMAGE_INTERP_TYPE, py_interp, (gpointer)&interp))
        return NULL;
    
    ret = pgm_image_set_interp(PGM_IMAGE(self->obj), interp);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 333 "pgmimage.override"
static PyObject *
_wrap_pgm_image_get_interp (PyGObject *self)
{
  PgmImageInterpType interp;

  pgm_image_get_interp (PGM_IMAGE (self->obj), &interp);

  return pyg_enum_from_gtype (PGM_TYPE_IMAGE_INTERP_TYPE, interp);
}

#line 2312 "./pgm.c"


static PyObject *
_wrap_pgm_image_set_aspect_ratio(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "numerator", "denominator", NULL };
    PyObject *py_numerator = NULL, *py_denominator = NULL;
    gint ret;
    guint numerator = 0, denominator = 0;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"OO:PgmImage.set_aspect_ratio", kwlist, &py_numerator, &py_denominator))
        return NULL;
    if (py_numerator) {
        if (PyLong_Check(py_numerator))
            numerator = PyLong_AsUnsignedLong(py_numerator);
        else if (PyInt_Check(py_numerator))
            numerator = PyInt_AsLong(py_numerator);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'numerator' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    if (py_denominator) {
        if (PyLong_Check(py_denominator))
            denominator = PyLong_AsUnsignedLong(py_denominator);
        else if (PyInt_Check(py_denominator))
            denominator = PyInt_AsLong(py_denominator);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'denominator' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    
    ret = pgm_image_set_aspect_ratio(PGM_IMAGE(self->obj), numerator, denominator);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 345 "pgmimage.override"
static PyObject *
_wrap_pgm_image_get_aspect_ratio (PyGObject *self)
{
  guint numerator, denominator;
  PyObject *py_tuple = NULL;

  pgm_image_get_aspect_ratio (PGM_IMAGE (self->obj), &numerator, &denominator);

  py_tuple = PyTuple_New (2);
  PyTuple_SetItem (py_tuple, 0, PyInt_FromLong (numerator));
  PyTuple_SetItem (py_tuple, 1, PyInt_FromLong (denominator));

  return py_tuple;
}

#line 2367 "./pgm.c"


#line 436 "pgmimage.override"
static PyObject *
_wrap_pgm_image_alloc_gst_buffer (PyGObject *self,
                                  PyObject *args,
                                  PyObject *kwargs)
{
  static char *kwlist[] = { "format", "width", "height", "size", NULL };
  PyObject *py_format = NULL, *py_width = NULL, *py_height = NULL;
  PyObject *py_size = NULL;
  PgmImagePixelFormat format;
  gint ret;
  PyGObject *py_buffer;
  GstBuffer *buffer;
  guint width = 0, height = 0, size = 0;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                   "OOOO:PgmImage.set_image_from_gst_buffer",
                                   kwlist, &py_format, &py_width, &py_height,
                                   &py_size))
    return NULL;

  if (pyg_enum_get_value (PGM_TYPE_IMAGE_PIXEL_FORMAT, py_format,
                          (gint *) &format))
    return NULL;
  if (py_width)
    {
      if (PyLong_Check (py_width))
        width = PyLong_AsUnsignedLong (py_width);
      else if (PyInt_Check (py_width))
        width = PyInt_AsLong (py_width);
      else
        PyErr_SetString (PyExc_TypeError,
                         "Parameter 'width' must be an int or a long");
      if (PyErr_Occurred ())
        return NULL;
    }
  if (py_height)
    {
      if (PyLong_Check (py_height))
        height = PyLong_AsUnsignedLong (py_height);
      else if (PyInt_Check (py_height))
        height = PyInt_AsLong (py_height);
      else
        PyErr_SetString (PyExc_TypeError,
                         "Parameter 'height' must be an int or a long");
      if (PyErr_Occurred ())
        return NULL;
    }
  if (py_size)
    {
      if (PyLong_Check (py_size))
        size = PyLong_AsUnsignedLong (py_size);
      else if (PyInt_Check (py_size))
        size = PyInt_AsLong (py_size);
      else
        PyErr_SetString (PyExc_TypeError,
                         "Parameter 'size' must be an int or a long");
      if (PyErr_Occurred ())
        return NULL;
    }

  pyg_begin_allow_threads;
  ret = pgm_image_alloc_gst_buffer (PGM_IMAGE (self->obj), &buffer, format,
                                    width, height, size);
  pyg_end_allow_threads;

  //return pyg_boxed_new (GST_TYPE_BUFFER, buffer, FALSE, TRUE);
  return (PyObject *) buffer;
}

#line 2440 "./pgm.c"


static const PyMethodDef _PyPgmImage_methods[] = {
    { "set_from_buffer", (PyCFunction)_wrap_pgm_image_set_from_buffer, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "set_from_gst_buffer", (PyCFunction)_wrap_pgm_image_set_from_gst_buffer, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "set_from_fd", (PyCFunction)_wrap_pgm_image_set_from_fd, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "set_from_image", (PyCFunction)_wrap_pgm_image_set_from_image, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "clear", (PyCFunction)_wrap_pgm_image_clear, METH_NOARGS,
      NULL },
    { "get_storage_type", (PyCFunction)_wrap_pgm_image_get_storage_type, METH_NOARGS,
      NULL },
    { "set_alignment", (PyCFunction)_wrap_pgm_image_set_alignment, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_alignment", (PyCFunction)_wrap_pgm_image_get_alignment, METH_NOARGS,
      NULL },
    { "set_layout", (PyCFunction)_wrap_pgm_image_set_layout, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_layout", (PyCFunction)_wrap_pgm_image_get_layout, METH_NOARGS,
      NULL },
    { "set_interp", (PyCFunction)_wrap_pgm_image_set_interp, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_interp", (PyCFunction)_wrap_pgm_image_get_interp, METH_NOARGS,
      NULL },
    { "set_aspect_ratio", (PyCFunction)_wrap_pgm_image_set_aspect_ratio, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_aspect_ratio", (PyCFunction)_wrap_pgm_image_get_aspect_ratio, METH_NOARGS,
      NULL },
    { "alloc_gst_buffer", (PyCFunction)_wrap_pgm_image_alloc_gst_buffer, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

#line 109 "pgmimage.override"
static PyObject *
_wrap_pgm_image__get_storage_type (PyGObject *self,
                                   void *closure)
{
  return _wrap_pgm_image_get_storage_type (self);
}

#line 2485 "./pgm.c"


#line 118 "pgmimage.override"
static PyObject *
_wrap_pgm_image__get_layout (PyGObject *self,
                             void *closure)
{
  return _wrap_pgm_image_get_layout (self);
}

static int
_wrap_pgm_image__set_layout (PyGObject *self,
                             PyObject *value,
                             void *closure)
{
  PyObject *object;
  PgmImageLayoutType layout;

  if (pyg_enum_get_value (PGM_TYPE_IMAGE_LAYOUT_TYPE, value, (gint *) &layout))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_image_set_layout (PGM_IMAGE (self->obj), layout);

  return 0;
}

#line 2515 "./pgm.c"


#line 146 "pgmimage.override"
static PyObject *
_wrap_pgm_image__get_alignment (PyGObject *self,
                                void *closure)
{
  return _wrap_pgm_image_get_alignment (self);
}

static int
_wrap_pgm_image__set_alignment (PyGObject *self,
                                PyObject *value,
                                void *closure)
{
  PyObject *object;
  PgmImageAlignment alignment;

  if (pyg_enum_get_value (PGM_TYPE_IMAGE_ALIGNMENT, value,
                          (gint *) &alignment))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_image_set_alignment (PGM_IMAGE (self->obj), alignment);

  return 0;
}

#line 2546 "./pgm.c"


#line 175 "pgmimage.override"
static PyObject *
_wrap_pgm_image__get_interp (PyGObject *self,
                             void *closure)
{
  return _wrap_pgm_image_get_interp (self);
}

static int
_wrap_pgm_image__set_interp (PyGObject *self,
                             PyObject *value,
                             void *closure)
{
  PyObject *object;
  PgmImageInterpType interp;

  if (pyg_enum_get_value (PGM_TYPE_IMAGE_INTERP_TYPE, value, (gint *) &interp))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_image_set_interp (PGM_IMAGE (self->obj), interp);

  return 0;
}

#line 2576 "./pgm.c"


#line 203 "pgmimage.override"
static PyObject *
_wrap_pgm_image__get_aspect_ratio (PyGObject *self,
                                   void *closure)
{
  return _wrap_pgm_image_get_aspect_ratio (self);
}

static int
_wrap_pgm_image__set_aspect_ratio (PyGObject *self,
                                   PyObject *value,
                                   void *closure)
{
  PyObject *object;
  gint numerator, denominator;

  object = PyTuple_GetItem (value, 0);
  numerator = PyInt_AsLong (object);
  object = PyTuple_GetItem (value, 1);
  denominator = PyInt_AsLong (object);

  if (PyErr_Occurred ())
    return -1;

  pgm_image_set_aspect_ratio (PGM_IMAGE (self->obj), numerator, denominator);

  return 0;
}

#line 2608 "./pgm.c"


#line 233 "pgmimage.override"
static PyObject *
_wrap_pgm_image__get_aspect_ratio_numerator (PyGObject *self,
                                             void *closure)
{
  guint numerator, denominator;

  pgm_image_get_aspect_ratio (PGM_IMAGE (self->obj), &numerator, &denominator);

  return PyInt_FromLong (numerator);
}

static int
_wrap_pgm_image__set_aspect_ratio_numerator (PyGObject *self,
                                             PyObject *value,
                                             void *closure)
{
  guint numerator, _numerator, denominator;

  _numerator = PyInt_AsLong (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_image_get_aspect_ratio (PGM_IMAGE (self->obj), &numerator, &denominator);
  pgm_image_set_aspect_ratio (PGM_IMAGE (self->obj), _numerator, denominator);

  return 0;
}

#line 2641 "./pgm.c"


#line 264 "pgmimage.override"
static PyObject *
_wrap_pgm_image__get_aspect_ratio_denominator (PyGObject *self,
                                               void *closure)
{
  guint numerator, denominator;

  pgm_image_get_aspect_ratio (PGM_IMAGE (self->obj), &numerator, &denominator);

  return PyInt_FromLong (denominator);
}

static int
_wrap_pgm_image__set_aspect_ratio_denominator (PyGObject *self,
                                               PyObject *value,
                                               void *closure)
{
  guint numerator, denominator, _denominator;

  _denominator = PyInt_AsLong (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_image_get_aspect_ratio (PGM_IMAGE (self->obj), &numerator, &denominator);
  pgm_image_set_aspect_ratio (PGM_IMAGE (self->obj), numerator, _denominator);

  return 0;
}

/* Methods override */

#line 2676 "./pgm.c"


static const PyGetSetDef pgm_image_getsets[] = {
    { "storage_type", (getter)_wrap_pgm_image__get_storage_type, (setter)0 },
    { "layout", (getter)_wrap_pgm_image__get_layout, (setter)_wrap_pgm_image__set_layout },
    { "alignment", (getter)_wrap_pgm_image__get_alignment, (setter)_wrap_pgm_image__set_alignment },
    { "interp", (getter)_wrap_pgm_image__get_interp, (setter)_wrap_pgm_image__set_interp },
    { "aspect_ratio", (getter)_wrap_pgm_image__get_aspect_ratio, (setter)_wrap_pgm_image__set_aspect_ratio },
    { "aspect_ratio_numerator", (getter)_wrap_pgm_image__get_aspect_ratio_numerator, (setter)_wrap_pgm_image__set_aspect_ratio_numerator },
    { "aspect_ratio_denominator", (getter)_wrap_pgm_image__get_aspect_ratio_denominator, (setter)_wrap_pgm_image__set_aspect_ratio_denominator },
    { NULL, (getter)0, (setter)0 },
};

PyTypeObject G_GNUC_INTERNAL PyPgmImage_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "pgm.Image",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyPgmImage_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)pgm_image_getsets,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_pgm_image_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PgmText ----------- */

#line 592 "pgmtext.override"
static int
_wrap_pgm_text_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "text", NULL };
  PyObject *text;
  gchar *encoded_text;

  if ((PyTuple_Size (args) == 0))
    encoded_text = "";
  else
    {
      if (!PyArg_ParseTupleAndKeywords (args, kwargs, "O:pgm.Text.__init__",
                                        kwlist, &text))
        return -1;
      encoded_text = encode_string (text);
      if (!encoded_text)
        return -1;

    }

  self->obj = G_OBJECT (pgm_text_new (encoded_text));

  pygobject_constructv (self, 0, NULL);
  if (!self->obj)
    {
      PyErr_SetString (PyExc_RuntimeError, "could not create pgm.Text object");
      return -1;
    }

  pygobject_register_wrapper ((PyObject *) self);

  return 0;
}

#line 2774 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_label(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "label", NULL };
    char *label;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:PgmText.set_label", kwlist, &label))
        return NULL;
    
    ret = pgm_text_set_label(PGM_TEXT(self->obj), label);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

static PyObject *
_wrap_pgm_text_set_markup(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "markup", NULL };
    char *markup;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:PgmText.set_markup", kwlist, &markup))
        return NULL;
    
    ret = pgm_text_set_markup(PGM_TEXT(self->obj), markup);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 628 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_label (PyGObject *self)
{
  gchar *label = NULL;
  PyObject *py_string = NULL;

  pgm_text_get_label (PGM_TEXT (self->obj), &label);

  py_string = PyString_FromStringAndSize (label, strlen (label));
  g_free (label);

  if (!py_string)
    {
      Py_INCREF (Py_None);
      return (Py_None);
    }

  return py_string;
}

#line 2828 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_font_family(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "font_family", NULL };
    char *font_family;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:PgmText.set_font_family", kwlist, &font_family))
        return NULL;
    
    ret = pgm_text_set_font_family(PGM_TEXT(self->obj), font_family);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 650 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_font_family (PyGObject *self)
{
  gchar *font_family = NULL;
  PyObject *py_string = NULL;

  pgm_text_get_font_family (PGM_TEXT (self->obj), &font_family);

  py_string = PyString_FromStringAndSize (font_family, strlen (font_family));
  g_free (font_family);

  if (!py_string)
    {
      Py_INCREF (Py_None);
      return (Py_None);
    }

  return py_string;
}

#line 2867 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_font_height(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "font_height", NULL };
    double font_height;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"d:PgmText.set_font_height", kwlist, &font_height))
        return NULL;
    
    ret = pgm_text_set_font_height(PGM_TEXT(self->obj), font_height);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 672 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_font_height (PyGObject *self)
{
  gfloat font_height;

  pgm_text_get_font_height (PGM_TEXT (self->obj), &font_height);

  return PyFloat_FromDouble (font_height);
}

#line 2896 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_ellipsize(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "ellipsize", NULL };
    PyObject *py_ellipsize = NULL;
    PgmTextEllipsize ellipsize;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmText.set_ellipsize", kwlist, &py_ellipsize))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_TEXT_ELLIPSIZE, py_ellipsize, (gpointer)&ellipsize))
        return NULL;
    
    ret = pgm_text_set_ellipsize(PGM_TEXT(self->obj), ellipsize);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 684 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_ellipsize (PyGObject *self)
{
  PgmTextEllipsize ellipsize;

  pgm_text_get_ellipsize (PGM_TEXT (self->obj), &ellipsize);

  return pyg_enum_from_gtype (PGM_TYPE_TEXT_ELLIPSIZE, ellipsize);
}

#line 2928 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_justify(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "justify", NULL };
    int justify;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:PgmText.set_justify", kwlist, &justify))
        return NULL;
    
    ret = pgm_text_set_justify(PGM_TEXT(self->obj), justify);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 696 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_justify (PyGObject *self)
{
  gboolean justify;

  pgm_text_get_justify (PGM_TEXT (self->obj), &justify);
  return PyBool_FromLong(justify);
}

#line 2956 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_alignment(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "alignment", NULL };
    PgmTextAlignment alignment;
    PyObject *py_alignment = NULL;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmText.set_alignment", kwlist, &py_alignment))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_TEXT_ALIGNMENT, py_alignment, (gpointer)&alignment))
        return NULL;
    
    ret = pgm_text_set_alignment(PGM_TEXT(self->obj), alignment);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 707 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_alignment (PyGObject *self)
{
  PgmTextAlignment alignment;

  pgm_text_get_alignment (PGM_TEXT (self->obj), &alignment);

  return pyg_enum_from_gtype (PGM_TYPE_TEXT_ALIGNMENT, alignment);
}

#line 2988 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_wrap(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "wrap", NULL };
    PyObject *py_wrap = NULL;
    gint ret;
    PgmTextWrap wrap;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmText.set_wrap", kwlist, &py_wrap))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_TEXT_WRAP, py_wrap, (gpointer)&wrap))
        return NULL;
    
    ret = pgm_text_set_wrap(PGM_TEXT(self->obj), wrap);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 719 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_wrap (PyGObject *self)
{
  PgmTextWrap wrap;

  pgm_text_get_wrap (PGM_TEXT (self->obj), &wrap);

  return pyg_enum_from_gtype (PGM_TYPE_TEXT_WRAP, wrap);
}

#line 3020 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_gravity(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "gravity", NULL };
    PyObject *py_gravity = NULL;
    PgmTextGravity gravity;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmText.set_gravity", kwlist, &py_gravity))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_TEXT_GRAVITY, py_gravity, (gpointer)&gravity))
        return NULL;
    
    ret = pgm_text_set_gravity(PGM_TEXT(self->obj), gravity);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 731 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_gravity (PyGObject *self)
{
  PgmTextGravity gravity;

  pgm_text_get_gravity (PGM_TEXT (self->obj), &gravity);

  return pyg_enum_from_gtype (PGM_TYPE_TEXT_GRAVITY, gravity);
}

#line 3052 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_stretch(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "stretch", NULL };
    PyObject *py_stretch = NULL;
    PgmTextStretch stretch;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmText.set_stretch", kwlist, &py_stretch))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_TEXT_STRETCH, py_stretch, (gpointer)&stretch))
        return NULL;
    
    ret = pgm_text_set_stretch(PGM_TEXT(self->obj), stretch);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 743 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_stretch (PyGObject *self)
{
  PgmTextStretch stretch;

  pgm_text_get_stretch (PGM_TEXT (self->obj), &stretch);

  return pyg_enum_from_gtype (PGM_TYPE_TEXT_STRETCH, stretch);
}

#line 3084 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_style(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "style", NULL };
    PyObject *py_style = NULL;
    PgmTextStyle style;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmText.set_style", kwlist, &py_style))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_TEXT_STYLE, py_style, (gpointer)&style))
        return NULL;
    
    ret = pgm_text_set_style(PGM_TEXT(self->obj), style);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 755 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_style (PyGObject *self)
{
  PgmTextStyle style;

  pgm_text_get_style (PGM_TEXT (self->obj), &style);

  return pyg_enum_from_gtype (PGM_TYPE_TEXT_STYLE, style);
}

#line 3116 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_variant(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "variant", NULL };
    PyObject *py_variant = NULL;
    gint ret;
    PgmTextVariant variant;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmText.set_variant", kwlist, &py_variant))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_TEXT_VARIANT, py_variant, (gpointer)&variant))
        return NULL;
    
    ret = pgm_text_set_variant(PGM_TEXT(self->obj), variant);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 767 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_variant (PyGObject *self)
{
  PgmTextVariant variant;

  pgm_text_get_variant (PGM_TEXT (self->obj), &variant);

  return pyg_enum_from_gtype (PGM_TYPE_TEXT_VARIANT, variant);
}

#line 3148 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_weight(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "weight", NULL };
    PyObject *py_weight = NULL;
    PgmTextWeight weight;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmText.set_weight", kwlist, &py_weight))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_TEXT_WEIGHT, py_weight, (gpointer)&weight))
        return NULL;
    
    ret = pgm_text_set_weight(PGM_TEXT(self->obj), weight);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 779 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_weight (PyGObject *self)
{
  PgmTextWeight weight;

  pgm_text_get_weight (PGM_TEXT (self->obj), &weight);

  return pyg_enum_from_gtype (PGM_TYPE_TEXT_WEIGHT, weight);
}

#line 3180 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_line_spacing(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "line_spacing", NULL };
    double line_spacing;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"d:PgmText.set_line_spacing", kwlist, &line_spacing))
        return NULL;
    
    ret = pgm_text_set_line_spacing(PGM_TEXT(self->obj), line_spacing);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 791 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_line_spacing (PyGObject *self)
{
  gfloat line_spacing;

  pgm_text_get_line_spacing (PGM_TEXT (self->obj), &line_spacing);

  return PyFloat_FromDouble (line_spacing);
}

#line 3209 "./pgm.c"


#line 837 "pgmtext.override"
static PyObject *
_wrap_pgm_text_set_outline_color (PyGObject *self,
                                 PyObject *args,
                                 PyObject *kwargs)
{
  static char *kwlist[] = { "r", "g", "b", "a", NULL };
  gint r, g, b, a;
  gint ret;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "iiii", kwlist, &r, &g, &b,
                                    &a))
    return NULL;

  ret = pgm_text_set_outline_color (PGM_TEXT (self->obj), (guchar) r,
                                   (guchar) g, (guchar) b, (guchar) a);

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, ret);
}
#line 3231 "./pgm.c"


#line 817 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_outline_color (PyGObject *self)
{
  guchar r, g, b, a;
  PyObject *py_tuple = NULL;

  pgm_text_get_outline_color (PGM_TEXT (self->obj), &r, &g, &b, &a);

  py_tuple = PyTuple_New (4);
  PyTuple_SetItem (py_tuple, 0, PyInt_FromLong ((long) r));
  PyTuple_SetItem (py_tuple, 1, PyInt_FromLong ((long) g));
  PyTuple_SetItem (py_tuple, 2, PyInt_FromLong ((long) b));
  PyTuple_SetItem (py_tuple, 3, PyInt_FromLong ((long) a));

  return py_tuple;
}


#line 3253 "./pgm.c"


static PyObject *
_wrap_pgm_text_set_outline_width(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "width", NULL };
    double width;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"d:PgmText.set_outline_width", kwlist, &width))
        return NULL;
    
    ret = pgm_text_set_outline_width(PGM_TEXT(self->obj), width);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 803 "pgmtext.override"
static PyObject *
_wrap_pgm_text_get_outline_width (PyGObject *self)
{
  gfloat outline_width;

  pgm_text_get_outline_width (PGM_TEXT (self->obj), &outline_width);

  return PyFloat_FromDouble (outline_width);
}



#line 3284 "./pgm.c"


static const PyMethodDef _PyPgmText_methods[] = {
    { "set_label", (PyCFunction)_wrap_pgm_text_set_label, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "set_markup", (PyCFunction)_wrap_pgm_text_set_markup, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_label", (PyCFunction)_wrap_pgm_text_get_label, METH_NOARGS,
      NULL },
    { "set_font_family", (PyCFunction)_wrap_pgm_text_set_font_family, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_font_family", (PyCFunction)_wrap_pgm_text_get_font_family, METH_NOARGS,
      NULL },
    { "set_font_height", (PyCFunction)_wrap_pgm_text_set_font_height, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_font_height", (PyCFunction)_wrap_pgm_text_get_font_height, METH_NOARGS,
      NULL },
    { "set_ellipsize", (PyCFunction)_wrap_pgm_text_set_ellipsize, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_ellipsize", (PyCFunction)_wrap_pgm_text_get_ellipsize, METH_NOARGS,
      NULL },
    { "set_justify", (PyCFunction)_wrap_pgm_text_set_justify, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_justify", (PyCFunction)_wrap_pgm_text_get_justify, METH_NOARGS,
      NULL },
    { "set_alignment", (PyCFunction)_wrap_pgm_text_set_alignment, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_alignment", (PyCFunction)_wrap_pgm_text_get_alignment, METH_NOARGS,
      NULL },
    { "set_wrap", (PyCFunction)_wrap_pgm_text_set_wrap, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_wrap", (PyCFunction)_wrap_pgm_text_get_wrap, METH_NOARGS,
      NULL },
    { "set_gravity", (PyCFunction)_wrap_pgm_text_set_gravity, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_gravity", (PyCFunction)_wrap_pgm_text_get_gravity, METH_NOARGS,
      NULL },
    { "set_stretch", (PyCFunction)_wrap_pgm_text_set_stretch, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_stretch", (PyCFunction)_wrap_pgm_text_get_stretch, METH_NOARGS,
      NULL },
    { "set_style", (PyCFunction)_wrap_pgm_text_set_style, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_style", (PyCFunction)_wrap_pgm_text_get_style, METH_NOARGS,
      NULL },
    { "set_variant", (PyCFunction)_wrap_pgm_text_set_variant, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_variant", (PyCFunction)_wrap_pgm_text_get_variant, METH_NOARGS,
      NULL },
    { "set_weight", (PyCFunction)_wrap_pgm_text_set_weight, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_weight", (PyCFunction)_wrap_pgm_text_get_weight, METH_NOARGS,
      NULL },
    { "set_line_spacing", (PyCFunction)_wrap_pgm_text_set_line_spacing, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_line_spacing", (PyCFunction)_wrap_pgm_text_get_line_spacing, METH_NOARGS,
      NULL },
    { "set_outline_color", (PyCFunction)_wrap_pgm_text_set_outline_color, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_outline_color", (PyCFunction)_wrap_pgm_text_get_outline_color, METH_NOARGS,
      NULL },
    { "set_outline_width", (PyCFunction)_wrap_pgm_text_set_outline_width, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_outline_width", (PyCFunction)_wrap_pgm_text_get_outline_width, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

#line 30 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_label (PyGObject *self,
                           void *closure)
{
  return _wrap_pgm_text_get_label (self);
}

static int
_wrap_pgm_text__set_label (PyGObject *self,
                           PyObject *value,
                           void *closure)
{
  gchar *label = encode_string (value);

  if (!label)
    return -1;

  pgm_text_set_label (PGM_TEXT (self->obj), label);

  return 0;
}

#line 3376 "./pgm.c"


#line 54 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_markup (PyGObject *self,
                            void *closure)
{
  return _wrap_pgm_text_get_label (self);
}

static int
_wrap_pgm_text__set_markup (PyGObject *self,
                            PyObject *value,
                            void *closure)
{
  gchar *label = encode_string (value);

  if (!label)
    return -1;

  pgm_text_set_markup (PGM_TEXT (self->obj), label);

  return 0;
}

#line 3402 "./pgm.c"


#line 78 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_font_family (PyGObject *self,
                                 void *closure)
{
  return _wrap_pgm_text_get_font_family (self);
}

static int
_wrap_pgm_text__set_font_family (PyGObject *self,
                                 PyObject *value,
                                 void *closure)
{
  gchar *family = encode_string (value);

  if (!family)
    return -1;

  pgm_text_set_font_family (PGM_TEXT (self->obj), family);

  return 0;
}

#line 3428 "./pgm.c"


#line 102 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_font_height (PyGObject *self,
                                 void *closure)
{
  return _wrap_pgm_text_get_font_height (self);
}

static int
_wrap_pgm_text__set_font_height (PyGObject *self,
                                 PyObject *value,
                                 void *closure)
{
  gfloat font_height;

  font_height = PyFloat_AsDouble (value);
  if (PyErr_Occurred ())
    return -1;

  pgm_text_set_font_height (PGM_TEXT (self->obj), font_height);

  return 0;
}

#line 3455 "./pgm.c"


#line 127 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_ellipsize (PyGObject *self,
                               void *closure)
{
  return _wrap_pgm_text_get_ellipsize (self);
}

static int
_wrap_pgm_text__set_ellipsize (PyGObject *self,
                               PyObject *value,
                               void *closure)
{
  PyObject *object;
  PgmTextEllipsize ellipsize;

  if (pyg_enum_get_value (PGM_TYPE_TEXT_ELLIPSIZE, value, (gint *) &ellipsize))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_text_set_ellipsize (PGM_TEXT (self->obj), ellipsize);

  return 0;
}

#line 3485 "./pgm.c"


#line 155 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_justify (PyGObject *self,
                             void *closure)
{
  return _wrap_pgm_text_get_justify (self);
}

static int
_wrap_pgm_text__set_justify (PyGObject *self,
                             PyObject *value,
                             void *closure)
{
  gint justify;

  if (!PyBool_Check (value))
    {
      PyErr_SetString (PyExc_TypeError, "a boolean is required");
      return -1;
    }

  justify = PyInt_AsLong (value);
  pgm_text_set_justify (PGM_TEXT (self->obj), justify);

  return 0;
}

#line 3515 "./pgm.c"


#line 183 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_alignment (PyGObject *self,
                               void *closure)
{
  return _wrap_pgm_text_get_alignment (self);
}

static int
_wrap_pgm_text__set_alignment (PyGObject *self,
                               PyObject *value,
                               void *closure)
{
  PyObject *object;
  PgmTextAlignment alignment;

  if (pyg_enum_get_value (PGM_TYPE_TEXT_ALIGNMENT, value, (gint *) &alignment))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_text_set_alignment (PGM_TEXT (self->obj), alignment);

  return 0;
}

#line 3545 "./pgm.c"


#line 211 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_wrap (PyGObject *self,
                          void *closure)
{
  return _wrap_pgm_text_get_wrap (self);
}

static int
_wrap_pgm_text__set_wrap (PyGObject *self,
                          PyObject *value,
                          void *closure)
{
  PyObject *object;
  PgmTextWrap wrap;

  if (pyg_enum_get_value (PGM_TYPE_TEXT_WRAP, value, (gint *) &wrap))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_text_set_wrap (PGM_TEXT (self->obj), wrap);

  return 0;
}

#line 3575 "./pgm.c"


#line 239 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_gravity (PyGObject *self,
                             void *closure)
{
  return _wrap_pgm_text_get_gravity (self);
}

static int
_wrap_pgm_text__set_gravity (PyGObject *self,
                             PyObject *value,
                             void *closure)
{
  PyObject *object;
  PgmTextGravity gravity;

  if (pyg_enum_get_value (PGM_TYPE_TEXT_GRAVITY, value, (gint *) &gravity))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_text_set_gravity (PGM_TEXT (self->obj), gravity);

  return 0;
}

#line 3605 "./pgm.c"


#line 267 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_stretch (PyGObject *self,
                             void *closure)
{
  return _wrap_pgm_text_get_stretch (self);
}

static int
_wrap_pgm_text__set_stretch (PyGObject *self,
                             PyObject *value,
                             void *closure)
{
  PyObject *object;
  PgmTextStretch stretch;

  if (pyg_enum_get_value (PGM_TYPE_TEXT_STRETCH, value, (gint *) &stretch))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_text_set_stretch (PGM_TEXT (self->obj), stretch);

  return 0;
}

#line 3635 "./pgm.c"


#line 295 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_style (PyGObject *self,
                           void *closure)
{
  return _wrap_pgm_text_get_style (self);
}

static int
_wrap_pgm_text__set_style (PyGObject *self,
                           PyObject *value,
                           void *closure)
{
  PyObject *object;
  PgmTextStyle style;

  if (pyg_enum_get_value (PGM_TYPE_TEXT_STYLE, value, (gint *) &style))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_text_set_style (PGM_TEXT (self->obj), style);

  return 0;
}

#line 3665 "./pgm.c"


#line 323 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_variant (PyGObject *self,
                             void *closure)
{
  return _wrap_pgm_text_get_variant (self);
}

static int
_wrap_pgm_text__set_variant (PyGObject *self,
                             PyObject *value,
                             void *closure)
{
  PyObject *object;
  PgmTextVariant variant;

  if (pyg_enum_get_value (PGM_TYPE_TEXT_VARIANT, value, (gint *) &variant))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_text_set_variant (PGM_TEXT (self->obj), variant);

  return 0;
}

#line 3695 "./pgm.c"


#line 351 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_weight (PyGObject *self,
                            void *closure)
{
  return _wrap_pgm_text_get_weight (self);
}

static int
_wrap_pgm_text__set_weight (PyGObject *self,
                            PyObject *value,
                            void *closure)
{
  PyObject *object;
  PgmTextWeight weight;

  if (pyg_enum_get_value (PGM_TYPE_TEXT_WEIGHT, value, (gint *) &weight))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_text_set_weight (PGM_TEXT (self->obj), weight);

  return 0;
}

#line 3725 "./pgm.c"


#line 379 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_line_spacing (PyGObject *self,
                                  void *closure)
{
  return _wrap_pgm_text_get_line_spacing (self);
}

static int
_wrap_pgm_text__set_line_spacing (PyGObject *self,
                                  PyObject *value,
                                  void *closure)
{
  gfloat spacing;

  spacing = PyFloat_AsDouble (value);
  if (PyErr_Occurred ())
    return -1;

  pgm_text_set_line_spacing (PGM_TEXT (self->obj), spacing);

  return 0;
}

#line 3752 "./pgm.c"


#line 404 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_outline_color (PyGObject *self,
                                   void *closure)
{
  return _wrap_pgm_text_get_outline_color (self);
}

static int
_wrap_pgm_text__set_outline_color (PyGObject *self,
                                   PyObject *value,
                                   void *closure)
{
  PyObject *object;
  guchar r, g, b, a;

  object = PyTuple_GetItem (value, 0);
  r = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);
  object = PyTuple_GetItem (value, 1);
  g = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);
  object = PyTuple_GetItem (value, 2);
  b = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);
  object = PyTuple_GetItem (value, 3);
  a = (guchar) CLAMP (PyInt_AsLong (object), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_text_set_outline_color (PGM_TEXT (self->obj), r, g, b, a);

  return 0;
}

#line 3788 "./pgm.c"


#line 438 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_outline_r (PyGObject *self,
                               void *closure)
{
  guchar r, g, b, a;

  pgm_text_get_outline_color (PGM_TEXT (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (r);
}

static int
_wrap_pgm_text__set_outline_r (PyGObject *self,
                               PyObject *value,
                               void *closure)
{
  guchar r, _r, g, b, a;

  _r = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_text_get_outline_color (PGM_TEXT (self->obj), &r, &g, &b, &a);
  pgm_text_set_outline_color (PGM_TEXT (self->obj), _r, g, b, a);

  return 0;
}

#line 3821 "./pgm.c"


#line 469 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_outline_g (PyGObject *self,
                               void *closure)
{
  guchar r, g, b, a;

  pgm_text_get_outline_color (PGM_TEXT (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (g);
}

static int
_wrap_pgm_text__set_outline_g (PyGObject *self,
                               PyObject *value,
                               void *closure)
{
  guchar r, g, _g, b, a;

  _g = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_text_get_outline_color (PGM_TEXT (self->obj), &r, &g, &b, &a);
  pgm_text_set_outline_color (PGM_TEXT (self->obj), r, _g, b, a);

  return 0;
}

#line 3854 "./pgm.c"


#line 500 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_outline_b (PyGObject *self,
                               void *closure)
{
  guchar r, g, b, a;

  pgm_text_get_outline_color (PGM_TEXT (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (b);
}

static int
_wrap_pgm_text__set_outline_b (PyGObject *self,
                               PyObject *value,
                               void *closure)
{
  guchar r, g, b, _b, a;

  _b = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_text_get_outline_color (PGM_TEXT (self->obj), &r, &g, &b, &a);
  pgm_text_set_outline_color (PGM_TEXT (self->obj), r, g, _b, a);

  return 0;
}

#line 3887 "./pgm.c"


#line 531 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_outline_a (PyGObject *self,
                               void *closure)
{
  guchar r, g, b, a;

  pgm_text_get_outline_color (PGM_TEXT (self->obj), &r, &g, &b, &a);

  return PyInt_FromLong (a);
}

static int
_wrap_pgm_text__set_outline_a (PyGObject *self,
                               PyObject *value,
                               void *closure)
{
  guchar r, g, b, a, _a;

  _a = (guchar) CLAMP (PyInt_AsLong (value), 0, 255);

  if (PyErr_Occurred ())
    return -1;

  pgm_text_get_outline_color (PGM_TEXT (self->obj), &r, &g, &b, &a);
  pgm_text_set_outline_color (PGM_TEXT (self->obj), r, g, b, _a);

  return 0;
}

#line 3920 "./pgm.c"


#line 562 "pgmtext.override"
static PyObject *
_wrap_pgm_text__get_outline_width (PyGObject *self,
                                   void *closure)
{
  return _wrap_pgm_text_get_outline_width (self);
}

static int
_wrap_pgm_text__set_outline_width (PyGObject *self,
                                   PyObject *value,
                                   void *closure)
{
  gfloat width;

  width = PyFloat_AsDouble (value);
  if (PyErr_Occurred ())
    return -1;

  pgm_text_set_outline_width (PGM_TEXT (self->obj), width);

  return 0;
}

/* Methods override */

#line 3949 "./pgm.c"


static const PyGetSetDef pgm_text_getsets[] = {
    { "label", (getter)_wrap_pgm_text__get_label, (setter)_wrap_pgm_text__set_label },
    { "markup", (getter)_wrap_pgm_text__get_markup, (setter)_wrap_pgm_text__set_markup },
    { "font_family", (getter)_wrap_pgm_text__get_font_family, (setter)_wrap_pgm_text__set_font_family },
    { "font_height", (getter)_wrap_pgm_text__get_font_height, (setter)_wrap_pgm_text__set_font_height },
    { "ellipsize", (getter)_wrap_pgm_text__get_ellipsize, (setter)_wrap_pgm_text__set_ellipsize },
    { "justify", (getter)_wrap_pgm_text__get_justify, (setter)_wrap_pgm_text__set_justify },
    { "alignment", (getter)_wrap_pgm_text__get_alignment, (setter)_wrap_pgm_text__set_alignment },
    { "wrap", (getter)_wrap_pgm_text__get_wrap, (setter)_wrap_pgm_text__set_wrap },
    { "gravity", (getter)_wrap_pgm_text__get_gravity, (setter)_wrap_pgm_text__set_gravity },
    { "stretch", (getter)_wrap_pgm_text__get_stretch, (setter)_wrap_pgm_text__set_stretch },
    { "style", (getter)_wrap_pgm_text__get_style, (setter)_wrap_pgm_text__set_style },
    { "variant", (getter)_wrap_pgm_text__get_variant, (setter)_wrap_pgm_text__set_variant },
    { "weight", (getter)_wrap_pgm_text__get_weight, (setter)_wrap_pgm_text__set_weight },
    { "line_spacing", (getter)_wrap_pgm_text__get_line_spacing, (setter)_wrap_pgm_text__set_line_spacing },
    { "outline_color", (getter)_wrap_pgm_text__get_outline_color, (setter)_wrap_pgm_text__set_outline_color },
    { "outline_r", (getter)_wrap_pgm_text__get_outline_r, (setter)_wrap_pgm_text__set_outline_r },
    { "outline_g", (getter)_wrap_pgm_text__get_outline_g, (setter)_wrap_pgm_text__set_outline_g },
    { "outline_b", (getter)_wrap_pgm_text__get_outline_b, (setter)_wrap_pgm_text__set_outline_b },
    { "outline_a", (getter)_wrap_pgm_text__get_outline_a, (setter)_wrap_pgm_text__set_outline_a },
    { "outline_width", (getter)_wrap_pgm_text__get_outline_width, (setter)_wrap_pgm_text__set_outline_width },
    { NULL, (getter)0, (setter)0 },
};

PyTypeObject G_GNUC_INTERNAL PyPgmText_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "pgm.Text",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyPgmText_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)pgm_text_getsets,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_pgm_text_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PgmViewport ----------- */

static PyObject *
_wrap_pgm_viewport_update(PyGObject *self)
{
    gint ret;

    
    ret = pgm_viewport_update(PGM_VIEWPORT(self->obj));
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

static PyObject *
_wrap_pgm_viewport_set_title(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "title", NULL };
    char *title;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:PgmViewport.set_title", kwlist, &title))
        return NULL;
    
    ret = pgm_viewport_set_title(PGM_VIEWPORT(self->obj), title);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 499 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_get_title (PyGObject *self)
{
  gchar *title = NULL;
  PyObject *py_string = NULL;

  pgm_viewport_get_title (PGM_VIEWPORT (self->obj), &title);

  py_string = PyString_FromStringAndSize (title, strlen (title));
  g_free (title);

  if (!py_string)
    {
      Py_INCREF (Py_None);
      return (Py_None);
    }

  return py_string;
}

#line 4072 "./pgm.c"


static PyObject *
_wrap_pgm_viewport_show(PyGObject *self)
{
    gint ret;

    
    ret = pgm_viewport_show(PGM_VIEWPORT(self->obj));
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

static PyObject *
_wrap_pgm_viewport_hide(PyGObject *self)
{
    gint ret;

    
    ret = pgm_viewport_hide(PGM_VIEWPORT(self->obj));
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 487 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_is_visible (PyGObject *self)
{
  gboolean visible;

  pgm_viewport_is_visible (PGM_VIEWPORT (self->obj), &visible);

  return PyBool_FromLong (visible);
}

#line 4108 "./pgm.c"


static PyObject *
_wrap_pgm_viewport_set_cursor(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "cursor", NULL };
    PyObject *py_cursor = NULL;
    PgmViewportCursor cursor;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmViewport.set_cursor", kwlist, &py_cursor))
        return NULL;
    if (pyg_enum_get_value(PGM_TYPE_VIEWPORT_CURSOR, py_cursor, (gpointer)&cursor))
        return NULL;
    
    ret = pgm_viewport_set_cursor(PGM_VIEWPORT(self->obj), cursor);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 521 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_get_cursor (PyGObject *self)
{
  PgmViewportCursor cursor;

  pgm_viewport_get_cursor (PGM_VIEWPORT (self->obj), &cursor);

  return pyg_enum_from_gtype (PGM_TYPE_VIEWPORT_CURSOR, cursor);
}

#line 4140 "./pgm.c"


#line 552 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_set_icon (PyGObject *self,
                             PyObject *args,
                             PyObject *kwargs)
{
  static char *kwlist[] = { "icon", NULL };
  PyObject *icon;
  GdkPixbuf *cicon = NULL;
  gint ret;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "O:PgmViewport.set_icon",
                                    kwlist, &icon))
    return NULL;

  if (Py_None != icon)
    {
      if (!pygobject_check (icon, &PyGdkPixbuf_Type))
        {
          PyErr_SetString (PyExc_TypeError, "a gtk.gdk.Pixbuf is required");
          return NULL;
        }

      cicon = GDK_PIXBUF (pygobject_get (icon));
    }

  ret = pgm_viewport_set_icon (PGM_VIEWPORT (self->obj), cicon);

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, ret);
}

#line 4174 "./pgm.c"


#line 533 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_get_icon (PyGObject *self)
{
  GdkPixbuf *icon;
  gint ret;

  ret = pgm_viewport_get_icon (PGM_VIEWPORT (self->obj), &icon);

  if (PGM_ERROR_OK != ret)
    PyErr_SetString (PyExc_RuntimeError, "problem while getting icon pixbuf");

  if (NULL == icon)
    Py_RETURN_NONE;

  return pygobject_new ((GObject *) icon);
}

#line 4195 "./pgm.c"


static PyObject *
_wrap_pgm_viewport_set_size(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "width", "height", NULL };
    int width, height;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ii:PgmViewport.set_size", kwlist, &width, &height))
        return NULL;
    
    ret = pgm_viewport_set_size(PGM_VIEWPORT(self->obj), width, height);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 584 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_get_size (PyGObject *self)
{
  gint width, height;
  PyObject *py_tuple = NULL;

  pgm_viewport_get_size (PGM_VIEWPORT (self->obj), &width, &height);

  py_tuple = PyTuple_New (2);
  PyTuple_SetItem (py_tuple, 0, PyInt_FromLong (width));
  PyTuple_SetItem (py_tuple, 1, PyInt_FromLong (height));

  return py_tuple;
}

#line 4229 "./pgm.c"


static PyObject *
_wrap_pgm_viewport_set_fullscreen(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "fullscreen", NULL };
    int fullscreen;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:PgmViewport.set_fullscreen", kwlist, &fullscreen))
        return NULL;
    
    ret = pgm_viewport_set_fullscreen(PGM_VIEWPORT(self->obj), fullscreen);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 601 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_get_fullscreen (PyGObject *self)
{
  gboolean fullscreen;

  pgm_viewport_get_fullscreen (PGM_VIEWPORT (self->obj), &fullscreen);

  return PyBool_FromLong (fullscreen);
}

#line 4258 "./pgm.c"


#line 689 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_get_screen_resolution (PyGObject *self)
{
  gint width, height;
  PyObject *py_tuple = NULL;

  pgm_viewport_get_screen_resolution (PGM_VIEWPORT (self->obj), &width,
                                      &height);

  py_tuple = PyTuple_New (2);
  PyTuple_SetItem (py_tuple, 0, PyInt_FromLong (width));
  PyTuple_SetItem (py_tuple, 1, PyInt_FromLong (height));

  return py_tuple;
}

#line 4278 "./pgm.c"


static PyObject *
_wrap_pgm_viewport_set_screen_resolution(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "width", "height", NULL };
    int width, height;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ii:PgmViewport.set_screen_resolution", kwlist, &width, &height))
        return NULL;
    
    ret = pgm_viewport_set_screen_resolution(PGM_VIEWPORT(self->obj), width, height);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 707 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_get_screen_size_mm (PyGObject *self)
{
  gint width, height;
  PyObject *py_tuple = NULL;

  pgm_viewport_get_screen_size_mm (PGM_VIEWPORT (self->obj), &width, &height);

  py_tuple = PyTuple_New (2);
  PyTuple_SetItem (py_tuple, 0, PyInt_FromLong (width));
  PyTuple_SetItem (py_tuple, 1, PyInt_FromLong (height));

  return py_tuple;
}

#line 4312 "./pgm.c"


static PyObject *
_wrap_pgm_viewport_set_screen_size_mm(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "width", "height", NULL };
    int width, height;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ii:PgmViewport.set_screen_size_mm", kwlist, &width, &height))
        return NULL;
    
    ret = pgm_viewport_set_screen_size_mm(PGM_VIEWPORT(self->obj), width, height);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

static PyObject *
_wrap_pgm_viewport_push_event(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "event", NULL };
    PgmEvent *event = NULL;
    PyObject *py_event;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:PgmViewport.push_event", kwlist, &py_event))
        return NULL;
    if (pyg_boxed_check(py_event, PGM_TYPE_EVENT))
        event = pyg_boxed_get(py_event, PgmEvent);
    else {
        PyErr_SetString(PyExc_TypeError, "event should be a PgmEvent");
        return NULL;
    }
    
    ret = pgm_viewport_push_event(PGM_VIEWPORT(self->obj), event);
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 724 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_get_canvas (PyGObject *self)
{
  PgmCanvas* canvas;
  PyObject* py_canvas;
  PgmError ret;

  ret = pgm_viewport_get_canvas (PGM_VIEWPORT (self->obj), &canvas);
  /* TODO: error management */

  py_canvas = pygobject_new ((GObject *) canvas);
  if (canvas)
    gst_object_unref (canvas);
  return py_canvas;
}


#line 4370 "./pgm.c"


#line 743 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_set_canvas (PyGObject *self,
                               PyObject *args,
                               PyObject *kwargs)
{
  static char *kwlist[] = { "canvas", NULL };
  PyObject  *py_canvas;
  gint ret;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,"O:PgmViewport.set_canvas",
                                    kwlist, &py_canvas))
    return NULL;

  if (!pygobject_check (py_canvas, &PyPgmCanvas_Type))
    {
      if (py_canvas == Py_None)
        ret = pgm_viewport_set_canvas (PGM_VIEWPORT (self->obj), NULL);
      else
        {
          PyErr_SetString (PyExc_TypeError,
                           "a pgm.Canvas or None object is required");
          return NULL;
        }
    }
  else
    {
      PyGObject *canvas = (PyGObject*) py_canvas;
      ret = pgm_viewport_set_canvas (PGM_VIEWPORT (self->obj),
                                     PGM_CANVAS (canvas->obj));
    }

  return pyg_enum_from_gtype (PGM_TYPE_ERROR, ret);
}

#line 4408 "./pgm.c"


static PyObject *
_wrap_pgm_viewport_update_projection(PyGObject *self)
{
    gint ret;

    
    ret = pgm_viewport_update_projection(PGM_VIEWPORT(self->obj));
    
    return pyg_enum_from_gtype(PGM_TYPE_ERROR, ret);
}

#line 806 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_to_canvas (PyGObject *self,
                              PyObject *args,
                              PyObject *kwargs)
{
  static char *kwlist[] = { "x", "y", "z", NULL };
  PyObject *py_tuple = NULL;
  gfloat canvas_x, canvas_y, canvas_z;
  gfloat x, y, z;
  PgmError ret;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "fff", kwlist, &x, &y, &z))
    return NULL;

  ret = pgm_viewport_to_canvas (PGM_VIEWPORT (self->obj), &canvas_x,
                                &canvas_y, &canvas_z, x, y, z);

  py_tuple = PyTuple_New (3);
  PyTuple_SetItem (py_tuple, 0, PyFloat_FromDouble (canvas_x));
  PyTuple_SetItem (py_tuple, 1, PyFloat_FromDouble (canvas_y));
  PyTuple_SetItem (py_tuple, 2, PyFloat_FromDouble (canvas_z));

  return py_tuple;
}
#line 4447 "./pgm.c"


#line 779 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_from_canvas (PyGObject *self,
                                PyObject *args,
                                PyObject *kwargs)
{
  static char *kwlist[] = { "x", "y", "z", NULL };
  PyObject *py_tuple = NULL;
  gfloat viewport_x, viewport_y, viewport_z;
  gfloat x, y, z;
  PgmError ret;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "fff", kwlist, &x, &y, &z))
    return NULL;

  ret = pgm_viewport_from_canvas (PGM_VIEWPORT (self->obj), &viewport_x,
                                  &viewport_y, &viewport_z, x, y, z);

  py_tuple = PyTuple_New (3);
  PyTuple_SetItem (py_tuple, 0, PyFloat_FromDouble (viewport_x));
  PyTuple_SetItem (py_tuple, 1, PyFloat_FromDouble (viewport_y));
  PyTuple_SetItem (py_tuple, 2, PyFloat_FromDouble (viewport_z));

  return py_tuple;
}

#line 4476 "./pgm.c"


#line 651 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_get_pixel_formats (PyGObject *self)
{
  PyObject *py_tuple = NULL;
  gulong mask = 0;
  guint size = 0;
  guint i;

  pgm_viewport_get_pixel_formats (PGM_VIEWPORT (self->obj), &mask);

  /* Get the size */
  for (i = 0; i < PGM_IMAGE_NB_PIXEL_FORMATS; i++)
    {
      if (mask & (1 << i))
        size++;
    }

  /* Build the tuple */
  py_tuple = PyTuple_New (size);

  /* And fill it */
  size = 0;
  for (i = 0; i < PGM_IMAGE_NB_PIXEL_FORMATS; i++)
    {
      if (mask & (1 << i))
        {
          PyTuple_SetItem (py_tuple, size,
                           pyg_flags_from_gtype (PGM_TYPE_IMAGE_PIXEL_FORMAT,
                                                 mask & (1 << i)));
          size++;
        }
    }

  return py_tuple;
}

#line 4516 "./pgm.c"


#line 613 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport_get_caps_mask (PyGObject *self)
{
  PyObject *py_tuple = NULL;
  gulong mask = 0;
  guint size = 0;
  guint i;

  pgm_viewport_get_caps_mask (PGM_VIEWPORT (self->obj), &mask);

  /* Get the size */
  for (i = 0; i < 3; i++)
    {
      if (mask & (1 << i))
        size++;
    }

  /* Build the tuple */
  py_tuple = PyTuple_New (size);

  /* And fill it */
  size = 0;
  for (i = 0; i < 3; i++)
    {
      if (mask & (1 << i))
        {
          PyTuple_SetItem (py_tuple, size,
                           pyg_flags_from_gtype (PGM_TYPE_VIEWPORT_CAPACITY,
                                                 mask & (1 << i)));
          size++;
        }
    }

  return py_tuple;
}

#line 4556 "./pgm.c"


static const PyMethodDef _PyPgmViewport_methods[] = {
    { "update", (PyCFunction)_wrap_pgm_viewport_update, METH_NOARGS,
      NULL },
    { "set_title", (PyCFunction)_wrap_pgm_viewport_set_title, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_title", (PyCFunction)_wrap_pgm_viewport_get_title, METH_NOARGS,
      NULL },
    { "show", (PyCFunction)_wrap_pgm_viewport_show, METH_NOARGS,
      NULL },
    { "hide", (PyCFunction)_wrap_pgm_viewport_hide, METH_NOARGS,
      NULL },
    { "is_visible", (PyCFunction)_wrap_pgm_viewport_is_visible, METH_NOARGS,
      NULL },
    { "set_cursor", (PyCFunction)_wrap_pgm_viewport_set_cursor, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_cursor", (PyCFunction)_wrap_pgm_viewport_get_cursor, METH_NOARGS,
      NULL },
    { "set_icon", (PyCFunction)_wrap_pgm_viewport_set_icon, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_icon", (PyCFunction)_wrap_pgm_viewport_get_icon, METH_NOARGS,
      NULL },
    { "set_size", (PyCFunction)_wrap_pgm_viewport_set_size, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_size", (PyCFunction)_wrap_pgm_viewport_get_size, METH_NOARGS,
      NULL },
    { "set_fullscreen", (PyCFunction)_wrap_pgm_viewport_set_fullscreen, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_fullscreen", (PyCFunction)_wrap_pgm_viewport_get_fullscreen, METH_NOARGS,
      NULL },
    { "get_screen_resolution", (PyCFunction)_wrap_pgm_viewport_get_screen_resolution, METH_NOARGS,
      NULL },
    { "set_screen_resolution", (PyCFunction)_wrap_pgm_viewport_set_screen_resolution, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_screen_size_mm", (PyCFunction)_wrap_pgm_viewport_get_screen_size_mm, METH_NOARGS,
      NULL },
    { "set_screen_size_mm", (PyCFunction)_wrap_pgm_viewport_set_screen_size_mm, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "push_event", (PyCFunction)_wrap_pgm_viewport_push_event, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_canvas", (PyCFunction)_wrap_pgm_viewport_get_canvas, METH_NOARGS,
      NULL },
    { "set_canvas", (PyCFunction)_wrap_pgm_viewport_set_canvas, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "update_projection", (PyCFunction)_wrap_pgm_viewport_update_projection, METH_NOARGS,
      NULL },
    { "to_canvas", (PyCFunction)_wrap_pgm_viewport_to_canvas, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "from_canvas", (PyCFunction)_wrap_pgm_viewport_from_canvas, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_pixel_formats", (PyCFunction)_wrap_pgm_viewport_get_pixel_formats, METH_NOARGS,
      NULL },
    { "get_caps_mask", (PyCFunction)_wrap_pgm_viewport_get_caps_mask, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

#line 32 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_title (PyGObject *self,
                               void *closure)
{
  return _wrap_pgm_viewport_get_title (self);
}

static int
_wrap_pgm_viewport__set_title (PyGObject *self,
                               PyObject *value,
                               void *closure)
{
  gchar *title = encode_string (value);

  if (!title)
      return -1;

  pgm_viewport_set_title (PGM_VIEWPORT (self->obj), title);

  return 0;
}



#line 4640 "./pgm.c"


#line 96 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_cursor (PyGObject *self,
                                void *closure)
{
  return _wrap_pgm_viewport_get_cursor (self);
}

static int
_wrap_pgm_viewport__set_cursor (PyGObject *self,
                                PyObject *value,
                                void *closure)
{
  PyObject *object;
  PgmViewportCursor cursor;

  if (pyg_enum_get_value (PGM_TYPE_VIEWPORT_CURSOR, value, (gint *) &cursor))
    {
      PyErr_SetString (PyExc_TypeError, "an integer is required");
      return -1;
    }

  pgm_viewport_set_cursor (PGM_VIEWPORT (self->obj), cursor);

  return 0;
}

#line 4670 "./pgm.c"


#line 124 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_icon (PyGObject *self,
                              void *closure)
{
  return _wrap_pgm_viewport_get_icon (self);
}

static int
_wrap_pgm_viewport__set_icon (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  PyObject *object;
  GdkPixbuf *icon = NULL;

  if (Py_None != value)
    {
      if (!pygobject_check(value, &PyGdkPixbuf_Type))
        {
          PyErr_SetString(PyExc_TypeError, "a gtk.gdk.Pixbuf is required");
          return -1;
        }

      icon = GDK_PIXBUF (pygobject_get (value));
    }

  pgm_viewport_set_icon (PGM_VIEWPORT (self->obj), icon);

  return 0;
}

#line 4705 "./pgm.c"


#line 157 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_size (PyGObject *self,
                              void *closure)
{
  return _wrap_pgm_viewport_get_size (self);
}

static int
_wrap_pgm_viewport__set_size (PyGObject *self,
                              PyObject *value,
                              void *closure)
{
  PyObject *object;
  gint width, height;

  object = PyTuple_GetItem (value, 0);
  width = PyInt_AsLong (object);
  object = PyTuple_GetItem (value, 1);
  height = PyInt_AsLong (object);

  if (PyErr_Occurred ())
    return -1;

  pgm_viewport_set_size (PGM_VIEWPORT (self->obj), width, height);

  return 0;
}

#line 4737 "./pgm.c"


#line 187 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_width (PyGObject *self,
                               void *closure)
{
  gint width, height;

  pgm_viewport_get_size (PGM_VIEWPORT (self->obj), &width, &height);

  return PyInt_FromLong (width);
}

static int
_wrap_pgm_viewport__set_width (PyGObject *self,
                               PyObject *value,
                               void *closure)
{
  gint width, _width, height;

  _width = PyInt_AsLong (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_viewport_get_size (PGM_VIEWPORT (self->obj), &width, &height);
  pgm_viewport_set_size (PGM_VIEWPORT (self->obj), _width, height);

  return 0;
}

#line 4770 "./pgm.c"


#line 218 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_height (PyGObject *self,
                                void *closure)
{
  gint width, height;

  pgm_viewport_get_size (PGM_VIEWPORT (self->obj), &width, &height);

  return PyInt_FromLong (height);
}

static int
_wrap_pgm_viewport__set_height (PyGObject *self,
                                PyObject *value,
                                void *closure)
{
  gint width, height, _height;

  _height = PyInt_AsLong (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_viewport_get_size (PGM_VIEWPORT (self->obj), &width, &height);
  pgm_viewport_set_size (PGM_VIEWPORT (self->obj), width, _height);

  return 0;
}

#line 4803 "./pgm.c"


#line 58 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_visible (PyGObject *self,
                                 void *closure)
{
  gboolean visible;

  pgm_viewport_is_visible (PGM_VIEWPORT (self->obj), &visible);

  if (visible)
    Py_RETURN_TRUE;
  else
    Py_RETURN_FALSE;
}

static int
_wrap_pgm_viewport__set_visible (PyGObject *self,
                                 PyObject *value,
                                 void *closure)
{
  gint show;

  if (!PyBool_Check (value))
    {
      PyErr_SetString (PyExc_TypeError, "a boolean is required");
      return -1;
    }

  show = PyInt_AsLong (value);
  if (show)
    pgm_viewport_show (PGM_VIEWPORT (self->obj));
  else
    pgm_viewport_hide (PGM_VIEWPORT (self->obj));

  return 0;
}

#line 4843 "./pgm.c"


#line 249 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_fullscreen (PyGObject *self,
                                    void *closure)
{
  return _wrap_pgm_viewport_get_fullscreen (self);
}

static int
_wrap_pgm_viewport__set_fullscreen (PyGObject *self,
                                    PyObject *value,
                                    void *closure)
{
  gint fullscreen;

  if (!PyBool_Check (value))
    {
      PyErr_SetString (PyExc_TypeError, "a boolean is required");
      return -1;
    }

  fullscreen = PyInt_AsLong (value);
  pgm_viewport_set_fullscreen (PGM_VIEWPORT (self->obj), fullscreen);

  return 0;
}

#line 4873 "./pgm.c"


#line 277 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_screen_resolution (PyGObject *self,
                                           void *closure)
{
  return _wrap_pgm_viewport_get_screen_resolution (self);
}

static int
_wrap_pgm_viewport__set_screen_resolution (PyGObject *self,
                                           PyObject *value,
                                           void *closure)
{
  PyObject *object;
  gint width, height;

  object = PyTuple_GetItem (value, 0);
  width = PyInt_AsLong (object);
  object = PyTuple_GetItem (value, 1);
  height = PyInt_AsLong (object);

  if (PyErr_Occurred ())
    return -1;

  pgm_viewport_set_screen_resolution (PGM_VIEWPORT (self->obj), width, height);

  return 0;
}

#line 4905 "./pgm.c"


#line 307 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_screen_resolution_width (PyGObject *self,
                                                 void *closure)
{
  gint width, height;

  pgm_viewport_get_screen_resolution (PGM_VIEWPORT (self->obj), &width,
                                      &height);

  return PyInt_FromLong (width);
}

static int
_wrap_pgm_viewport__set_screen_resolution_width (PyGObject *self,
                                                 PyObject *value,
                                                 void *closure)
{
  gint width, _width, height;

  _width = PyInt_AsLong (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_viewport_get_screen_resolution (PGM_VIEWPORT (self->obj), &width,
                                      &height);
  pgm_viewport_set_screen_resolution (PGM_VIEWPORT (self->obj), _width,
                                      height);

  return 0;
}

#line 4941 "./pgm.c"


#line 341 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_screen_resolution_height (PyGObject *self,
                                                  void *closure)
{
  gint width, height;

  pgm_viewport_get_screen_resolution (PGM_VIEWPORT (self->obj), &width,
                                      &height);

  return PyInt_FromLong (height);
}

static int
_wrap_pgm_viewport__set_screen_resolution_height (PyGObject *self,
                                                  PyObject *value,
                                                  void *closure)
{
  gint width, height, _height;

  _height = PyInt_AsLong (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_viewport_get_screen_resolution (PGM_VIEWPORT (self->obj), &width,
                                      &height);
  pgm_viewport_set_screen_resolution (PGM_VIEWPORT (self->obj), width,
                                      _height);

  return 0;
}

#line 4977 "./pgm.c"


#line 375 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_screen_size_mm (PyGObject *self,
                                        void *closure)
{
  return _wrap_pgm_viewport_get_screen_size_mm (self);
}

static int
_wrap_pgm_viewport__set_screen_size_mm (PyGObject *self,
                                        PyObject *value,
                                        void *closure)
{
  PyObject *object;
  gint width, height;

  object = PyTuple_GetItem (value, 0);
  width = PyInt_AsLong (object);
  object = PyTuple_GetItem (value, 1);
  height = PyInt_AsLong (object);

  if (PyErr_Occurred ())
    return -1;

  pgm_viewport_set_screen_size_mm (PGM_VIEWPORT (self->obj), width, height);

  return 0;
}

#line 5009 "./pgm.c"


#line 405 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_screen_size_mm_width (PyGObject *self,
                                              void *closure)
{
  gint width, height;

  pgm_viewport_get_screen_size_mm (PGM_VIEWPORT (self->obj), &width, &height);

  return PyInt_FromLong (width);
}

static int
_wrap_pgm_viewport__set_screen_size_mm_width (PyGObject *self,
                                              PyObject *value,
                                              void *closure)
{
  gint width, _width, height;

  _width = PyInt_AsLong (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_viewport_get_screen_size_mm (PGM_VIEWPORT (self->obj), &width, &height);
  pgm_viewport_set_screen_size_mm (PGM_VIEWPORT (self->obj), _width, height);

  return 0;
}

#line 5042 "./pgm.c"


#line 436 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_screen_size_mm_height (PyGObject *self,
                                               void *closure)
{
  gint width, height;

  pgm_viewport_get_screen_size_mm (PGM_VIEWPORT (self->obj), &width, &height);

  return PyInt_FromLong (height);
}

static int
_wrap_pgm_viewport__set_screen_size_mm_height (PyGObject *self,
                                               PyObject *value,
                                               void *closure)
{
  gint width, height, _height;

  _height = PyInt_AsLong (value);

  if (PyErr_Occurred ())
    return -1;

  pgm_viewport_get_screen_size_mm (PGM_VIEWPORT (self->obj), &width, &height);
  pgm_viewport_set_screen_size_mm (PGM_VIEWPORT (self->obj), width, _height);

  return 0;
}

#line 5075 "./pgm.c"


#line 467 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_pixel_formats (PyGObject *self,
                                       void *closure)
{
  return _wrap_pgm_viewport_get_pixel_formats (self);
}

#line 5086 "./pgm.c"


#line 476 "pgmviewport.override"
static PyObject *
_wrap_pgm_viewport__get_caps_mask (PyGObject *self,
                                       void *closure)
{
  return _wrap_pgm_viewport_get_caps_mask (self);
}

/* Methods override */

#line 5099 "./pgm.c"


static const PyGetSetDef pgm_viewport_getsets[] = {
    { "title", (getter)_wrap_pgm_viewport__get_title, (setter)_wrap_pgm_viewport__set_title },
    { "cursor", (getter)_wrap_pgm_viewport__get_cursor, (setter)_wrap_pgm_viewport__set_cursor },
    { "icon", (getter)_wrap_pgm_viewport__get_icon, (setter)_wrap_pgm_viewport__set_icon },
    { "size", (getter)_wrap_pgm_viewport__get_size, (setter)_wrap_pgm_viewport__set_size },
    { "width", (getter)_wrap_pgm_viewport__get_width, (setter)_wrap_pgm_viewport__set_width },
    { "height", (getter)_wrap_pgm_viewport__get_height, (setter)_wrap_pgm_viewport__set_height },
    { "visible", (getter)_wrap_pgm_viewport__get_visible, (setter)_wrap_pgm_viewport__set_visible },
    { "fullscreen", (getter)_wrap_pgm_viewport__get_fullscreen, (setter)_wrap_pgm_viewport__set_fullscreen },
    { "screen_resolution", (getter)_wrap_pgm_viewport__get_screen_resolution, (setter)_wrap_pgm_viewport__set_screen_resolution },
    { "screen_resolution_width", (getter)_wrap_pgm_viewport__get_screen_resolution_width, (setter)_wrap_pgm_viewport__set_screen_resolution_width },
    { "screen_resolution_height", (getter)_wrap_pgm_viewport__get_screen_resolution_height, (setter)_wrap_pgm_viewport__set_screen_resolution_height },
    { "screen_size_mm", (getter)_wrap_pgm_viewport__get_screen_size_mm, (setter)_wrap_pgm_viewport__set_screen_size_mm },
    { "screen_size_mm_width", (getter)_wrap_pgm_viewport__get_screen_size_mm_width, (setter)_wrap_pgm_viewport__set_screen_size_mm_width },
    { "screen_size_mm_height", (getter)_wrap_pgm_viewport__get_screen_size_mm_height, (setter)_wrap_pgm_viewport__set_screen_size_mm_height },
    { "pixel_formats", (getter)_wrap_pgm_viewport__get_pixel_formats, (setter)0 },
    { "caps_mask", (getter)_wrap_pgm_viewport__get_caps_mask, (setter)0 },
    { NULL, (getter)0, (setter)0 },
};

PyTypeObject G_GNUC_INTERNAL PyPgmViewport_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "pgm.Viewport",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyPgmViewport_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)pgm_viewport_getsets,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- PgmViewportFactory ----------- */

#line 31 "pgmviewportfactory.override"
static int
_wrap_pgm_viewport_factory_new (PyGObject *self,
                                PyObject *args,
                                PyObject *kwargs)
{
  static char *kwlist[] = { "name", NULL };
  gchar *name = NULL;

  if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                   "|s:PgmViewportFactory.__init__",
                                   kwlist, &name))
    return -1;

  if (name)
    self->obj = (GObject *) pgm_viewport_factory_new (name);
  else
    pygobject_construct (self, NULL);

  if (!self->obj)
    {
      PyErr_SetString (PyExc_RuntimeError,
                      "could not create PgmViewportFactory object");
      return -1;
    }

  pygobject_register_wrapper ((PyObject *) self);

  return 0;
}

/* Methods override */

#line 5204 "./pgm.c"


#line 65 "pgmviewportfactory.override"
static PyObject *
_wrap_pgm_viewport_factory_get_description (PyGObject *self)
{
  gchar *description = NULL;
  PyObject *py_string = NULL;

  pgm_viewport_factory_get_description (PGM_VIEWPORT_FACTORY (self->obj),
                                        &description);

  py_string = PyString_FromStringAndSize (description, strlen (description));
  g_free (description);

  if (!py_string)
    {
      Py_INCREF (Py_None);
      return (Py_None);
    }

  return py_string;
}

#line 5229 "./pgm.c"


#line 88 "pgmviewportfactory.override"
static PyObject *
_wrap_pgm_viewport_factory_get_license (PyGObject *self)
{
  gchar *license = NULL;
  PyObject *py_string = NULL;

  pgm_viewport_factory_get_license (PGM_VIEWPORT_FACTORY (self->obj),
                                    &license);

  py_string = PyString_FromStringAndSize (license, strlen (license));
  g_free (license);

  if (!py_string)
    {
      Py_INCREF (Py_None);
      return (Py_None);
    }

  return py_string;
}

#line 5254 "./pgm.c"


#line 111 "pgmviewportfactory.override"
static PyObject *
_wrap_pgm_viewport_factory_get_origin (PyGObject *self)
{
  gchar *origin = NULL;
  PyObject *py_string = NULL;

  pgm_viewport_factory_get_origin (PGM_VIEWPORT_FACTORY (self->obj),
                                   &origin);

  py_string = PyString_FromStringAndSize (origin, strlen (origin));
  g_free (origin);

  if (!py_string)
    {
      Py_INCREF (Py_None);
      return (Py_None);
    }

  return py_string;
}

#line 5279 "./pgm.c"


#line 134 "pgmviewportfactory.override"
static PyObject *
_wrap_pgm_viewport_factory_get_author (PyGObject *self)
{
  gchar *author = NULL;
  PyObject *py_string = NULL;

  pgm_viewport_factory_get_author (PGM_VIEWPORT_FACTORY (self->obj),
                                   &author);

  py_string = PyString_FromStringAndSize (author, strlen (author));
  g_free (author);

  if (!py_string)
    {
      Py_INCREF (Py_None);
      return (Py_None);
    }

  return py_string;
}

#line 5304 "./pgm.c"


#line 157 "pgmviewportfactory.override"
static PyObject *
_wrap_pgm_viewport_factory_create (PyGObject *self)
{
  PgmViewport *viewport;
  PyObject *py_ret = NULL;
  PgmError ret;

  ret = pgm_viewport_factory_create (PGM_VIEWPORT_FACTORY (self->obj),
                                     &viewport);

  py_ret = pygobject_new ((GObject *) viewport);
  g_object_unref ((GObject *) viewport);

  return py_ret;
}
#line 5323 "./pgm.c"


static const PyMethodDef _PyPgmViewportFactory_methods[] = {
    { "get_description", (PyCFunction)_wrap_pgm_viewport_factory_get_description, METH_NOARGS,
      NULL },
    { "get_license", (PyCFunction)_wrap_pgm_viewport_factory_get_license, METH_NOARGS,
      NULL },
    { "get_origin", (PyCFunction)_wrap_pgm_viewport_factory_get_origin, METH_NOARGS,
      NULL },
    { "get_author", (PyCFunction)_wrap_pgm_viewport_factory_get_author, METH_NOARGS,
      NULL },
    { "create", (PyCFunction)_wrap_pgm_viewport_factory_create, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyPgmViewportFactory_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "pgm.ViewportFactory",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyPgmViewportFactory_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_pgm_viewport_factory_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- functions ----------- */

#line 134 "./pgm.override"
static PyObject *
_wrap_pgm_version ()
{
  guint major, minor, micro, nano;
  PyObject *py_tuple = NULL;

  pgm_version (&major, &minor, &micro, &nano);

  py_tuple = PyTuple_New (4);
  PyTuple_SetItem (py_tuple, 0, PyInt_FromLong (major));
  PyTuple_SetItem (py_tuple, 1, PyInt_FromLong (minor));
  PyTuple_SetItem (py_tuple, 2, PyInt_FromLong (micro));
  PyTuple_SetItem (py_tuple, 3, PyInt_FromLong (nano));

  return py_tuple;
}

#line 5407 "./pgm.c"


#line 153 "./pgm.override"
static PyObject *
_wrap_pgm_version_string ()
{
  gchar *version = NULL;
  PyObject *py_string = NULL;

  version = pgm_version_string ();

  py_string = PyString_FromStringAndSize (version, strlen (version));
  g_free (version);

  if (!py_string)
    {
      Py_INCREF (Py_None);
      return (Py_None);
    }

  return py_string;
}

#line 5431 "./pgm.c"


static PyObject *
_wrap_pgm_events_pending(PyObject *self)
{
    int ret;

    
    ret = pgm_events_pending();
    
    return PyBool_FromLong(ret);

}

#line 175 "./pgm.override"

static gboolean
pypgm_signal_watch_prepare (GSource *source,
                            gint *timeout)
{
  /* Python only invokes signal handlers from the main thread, so if a thread
   * other than the main thread receives the signal from the kernel,
   * PyErr_CheckSignals() from that thread will do nothing. So, we need to time
   * out and check for signals regularily too. Also, on Windows g_poll() won't
   * be interrupted by a signal (AFAIK), so we need the timeout there too. */
#ifndef G_OS_WIN32
  if (pyg_threads_enabled)
#endif
    *timeout = 1000;

  return FALSE;
}

static gboolean
pypgm_signal_watch_check (GSource *source)
{
  PyGILState_STATE state;

  state = pyg_gil_state_ensure ();

  if (PyErr_CheckSignals () == -1)
    {
      PyErr_SetNone (PyExc_KeyboardInterrupt);
      pgm_main_quit ();
    }

  pyg_gil_state_release (state);

  return FALSE;
}

static gboolean
pypgm_signal_watch_dispatch (GSource *source,
                             GSourceFunc callback,
                             gpointer data)
{
  /* We should never be dispatched */
  g_assert_not_reached ();

  return TRUE;
}

static GSourceFuncs pypgm_signal_watch_funcs = {
  pypgm_signal_watch_prepare,
  pypgm_signal_watch_check,
  pypgm_signal_watch_dispatch,
  NULL
};

static PyObject *
_wrap_pgm_main (PyObject *self)
{
  GSource *main_watch;

  /* Call enable_threads again to ensure that the thread state is recorded */
  if (pyg_threads_enabled)
    pyg_enable_threads ();

  main_watch = g_source_new (&pypgm_signal_watch_funcs, sizeof (GSource));

  pyg_begin_allow_threads;

  g_source_attach (main_watch, NULL);
  pgm_main();
  g_source_destroy (main_watch);

  pyg_end_allow_threads;

  if (PyErr_Occurred ())
    return NULL;

  Py_INCREF (Py_None);
  return Py_None;
}

#line 5527 "./pgm.c"


#line 270 "./pgm.override"
static PyObject *
_wrap_pgm_main_quit (PyObject *self)
{
  pgm_main_quit ();

  Py_INCREF (Py_None);
  return Py_None;
}

#line 5540 "./pgm.c"


#line 257 "./pgm.override"
static PyObject *
_wrap_pgm_main_iteration (PyObject *self)
{
  pyg_begin_allow_threads;
  pgm_main_iteration_do (TRUE);
  pyg_end_allow_threads;

  Py_INCREF (Py_None);
  return Py_None;
}

#line 5555 "./pgm.c"


#line 281 "./pgm.override"
static PyObject *
_wrap_pgm_main_iteration_do (PyObject *self,
                             PyObject *args,
                             PyObject *kwargs)
{
  static char *kwlist[] = { "block", NULL };
  gint block = 1;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "|i:main_iteration_do",
                                    kwlist, &block))
    return NULL;

  pyg_begin_allow_threads;
  pgm_main_iteration_do (block);
  pyg_end_allow_threads;

  Py_INCREF (Py_None);
  return Py_None;
}



#line 5581 "./pgm.c"


#line 106 "./pgm.override"
static PyObject *
_wrap_pgm_viewport_factory_make (PyObject *self,
                                 PyObject *args,
                                 PyObject *kwargs)
{
  static gchar *kwlist[] = { "name", NULL };
  gchar *name;
  PyObject *py_ret;
  PgmError ret;
  PgmViewport *viewport;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "s", kwlist, &name))
    return NULL;

  ret = pgm_viewport_factory_make (name, &viewport);

  /* TODO: error check */

  py_ret = pygobject_new ((GObject *) viewport);

  /* TODO: re-enable that */
  //g_object_unref((GObject *)viewport);

  return py_ret;
}

#line 5611 "./pgm.c"


static PyObject *
_wrap_pgm_keyval_to_unicode(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "keyval", NULL };
    PyObject *py_keyval = NULL;
    guint32 ret;
    guint keyval = 0;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:keyval_to_unicode", kwlist, &py_keyval))
        return NULL;
    if (py_keyval) {
        if (PyLong_Check(py_keyval))
            keyval = PyLong_AsUnsignedLong(py_keyval);
        else if (PyInt_Check(py_keyval))
            keyval = PyInt_AsLong(py_keyval);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'keyval' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    
    ret = pgm_keyval_to_unicode(keyval);
    
    return PyLong_FromUnsignedLong(ret);

}

const PyMethodDef pypgm_functions[] = {
    { "version", (PyCFunction)_wrap_pgm_version, METH_NOARGS,
      NULL },
    { "version_string", (PyCFunction)_wrap_pgm_version_string, METH_NOARGS,
      NULL },
    { "pgm_events_pending", (PyCFunction)_wrap_pgm_events_pending, METH_NOARGS,
      NULL },
    { "main", (PyCFunction)_wrap_pgm_main, METH_NOARGS,
      NULL },
    { "main_quit", (PyCFunction)_wrap_pgm_main_quit, METH_NOARGS,
      NULL },
    { "main_iteration", (PyCFunction)_wrap_pgm_main_iteration, METH_NOARGS,
      NULL },
    { "main_iteration_do", (PyCFunction)_wrap_pgm_main_iteration_do, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "viewport_factory_make", (PyCFunction)_wrap_pgm_viewport_factory_make, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "keyval_to_unicode", (PyCFunction)_wrap_pgm_keyval_to_unicode, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};


/* ----------- enums and flags ----------- */

void
pypgm_add_constants(PyObject *module, const gchar *strip_prefix)
{
  pyg_enum_add(module, "Error", strip_prefix, PGM_TYPE_ERROR);
  pyg_enum_add(module, "DrawableLayer", strip_prefix, PGM_TYPE_DRAWABLE_LAYER);
  pyg_enum_add(module, "DrawableProperty", strip_prefix, PGM_TYPE_DRAWABLE_PROPERTY);
  pyg_flags_add(module, "DrawableFlags", strip_prefix, PGM_TYPE_DRAWABLE_FLAGS);
  pyg_enum_add(module, "EventType", strip_prefix, PGM_TYPE_EVENT_TYPE);
  pyg_flags_add(module, "ModifierType", strip_prefix, PGM_TYPE_MODIFIER_TYPE);
  pyg_flags_add(module, "ButtonType", strip_prefix, PGM_TYPE_BUTTON_TYPE);
  pyg_enum_add(module, "ScrollDirection", strip_prefix, PGM_TYPE_SCROLL_DIRECTION);
  pyg_flags_add(module, "ImageAlignment", strip_prefix, PGM_TYPE_IMAGE_ALIGNMENT);
  pyg_enum_add(module, "ImageLayoutType", strip_prefix, PGM_TYPE_IMAGE_LAYOUT_TYPE);
  pyg_enum_add(module, "ImageInterpType", strip_prefix, PGM_TYPE_IMAGE_INTERP_TYPE);
  pyg_flags_add(module, "ImagePixelFormat", strip_prefix, PGM_TYPE_IMAGE_PIXEL_FORMAT);
  pyg_enum_add(module, "ImageStorageType", strip_prefix, PGM_TYPE_IMAGE_STORAGE_TYPE);
  pyg_enum_add(module, "ViewportCursor", strip_prefix, PGM_TYPE_VIEWPORT_CURSOR);
  pyg_enum_add(module, "TextEllipsize", strip_prefix, PGM_TYPE_TEXT_ELLIPSIZE);
  pyg_enum_add(module, "TextAlignment", strip_prefix, PGM_TYPE_TEXT_ALIGNMENT);
  pyg_enum_add(module, "TextWrap", strip_prefix, PGM_TYPE_TEXT_WRAP);
  pyg_enum_add(module, "TextGravity", strip_prefix, PGM_TYPE_TEXT_GRAVITY);
  pyg_enum_add(module, "TextStretch", strip_prefix, PGM_TYPE_TEXT_STRETCH);
  pyg_enum_add(module, "TextStyle", strip_prefix, PGM_TYPE_TEXT_STYLE);
  pyg_enum_add(module, "TextVariant", strip_prefix, PGM_TYPE_TEXT_VARIANT);
  pyg_enum_add(module, "TextWeight", strip_prefix, PGM_TYPE_TEXT_WEIGHT);

  if (PyErr_Occurred())
    PyErr_Print();
}

/* initialise stuff extension classes */
void
pypgm_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        _PyGObject_Type = (PyTypeObject *)PyObject_GetAttrString(module, "GObject");
        if (_PyGObject_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name GObject from gobject");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gobject");
        return ;
    }
    if ((module = PyImport_ImportModule("gst")) != NULL) {
        _PyGstObject_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Object");
        if (_PyGstObject_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Object from gst");
            return ;
        }
        _PyGstBuffer_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Buffer");
        if (_PyGstBuffer_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Buffer from gst");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gst");
        return ;
    }
    if ((module = PyImport_ImportModule("gtk.gdk")) != NULL) {
        _PyGdkPixbuf_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Pixbuf");
        if (_PyGdkPixbuf_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Pixbuf from gtk.gdk");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gtk.gdk");
        return ;
    }


#line 88 "./pgm.override"


#line 5749 "./pgm.c"
    pyg_register_boxed(d, "Event", PGM_TYPE_EVENT, &PyPgmEvent_Type);
    pygobject_register_class(d, "PgmCanvas", PGM_TYPE_CANVAS, &PyPgmCanvas_Type, Py_BuildValue("(O)", &PyGstObject_Type));
    pyg_set_object_has_new_constructor(PGM_TYPE_CANVAS);
    pygobject_register_class(d, "PgmDrawable", PGM_TYPE_DRAWABLE, &PyPgmDrawable_Type, Py_BuildValue("(O)", &PyGstObject_Type));
    pygobject_register_class(d, "PgmImage", PGM_TYPE_IMAGE, &PyPgmImage_Type, Py_BuildValue("(O)", &PyPgmDrawable_Type));
    pyg_set_object_has_new_constructor(PGM_TYPE_IMAGE);
    pygobject_register_class(d, "PgmText", PGM_TYPE_TEXT, &PyPgmText_Type, Py_BuildValue("(O)", &PyPgmDrawable_Type));
    pyg_set_object_has_new_constructor(PGM_TYPE_TEXT);
    pygobject_register_class(d, "PgmViewport", PGM_TYPE_VIEWPORT, &PyPgmViewport_Type, Py_BuildValue("(O)", &PyGstObject_Type));
    pygobject_register_class(d, "PgmViewportFactory", PGM_TYPE_VIEWPORT_FACTORY, &PyPgmViewportFactory_Type, Py_BuildValue("(O)", &PyGstObject_Type));
    pyg_set_object_has_new_constructor(PGM_TYPE_VIEWPORT_FACTORY);
}
